utils::globalVariables(c("Scelta_DataFrame_Name", "All_DF_Name"))
FS4 <- function(){

img.path <- system.file("images", package = "FS4")
image_sx <- tclVar()
tkimage.create("photo", image_sx, file=paste(img.path, "//green.gif", sep=""))

image_dx <- tclVar()
tkimage.create("photo", image_dx, file=paste(img.path, "//red.gif", sep=""))

image_ok <- tclVar()
tkimage.create("photo", image_ok, file=paste(img.path, "//ok.gif", sep=""))

image_cancel <- tclVar()
tkimage.create("photo", image_cancel, file=paste(img.path, "//cancel.gif", sep=""))

image_help <- tclVar()
tkimage.create("photo", image_help, file=paste(img.path, "//help.gif", sep=""))

###########################
assignTemp("there.are.warnings", FALSE, replace.existing = TRUE)
options("max.print"=10^9)
Index_dataframe_old <- 0
Index_dataframe_oldAll <- 0
count <- FALSE
countAll <- FALSE
Min_sample_index <- FALSE

fontTextTitle <- tkfont.create(family="Helvetica", weight="bold",size=11)
fontTextWindow <- tkfont.create(family="courier", size=10)
fontTextLabel <- tkfont.create(family="Helvetica", weight="bold",size=10)
fontTextEntry <- tkfont.create(family="Arial", size=11)

VarScelta_DataFrame <- tclVar("")
VarScelta_DF_All <- tclVar("")
#############################################

tt <- tktoplevel()
tcl("wm", "protocol", tt, "WM_DELETE_WINDOW", function() fOnExit(tt, textHistory))

PKG.version <- packageDescription("FS4")$Version
title <- paste("First Stage Stratification and Selection in Sampling -", " Version ", PKG.version, sep="")
tkwm.title(tt, title)

tkwm.resizable(tt, 0, 0)

label_StratSel <- "StratSel"
########################################
commands <- tclVar("")

frameHistory<- tkframe(tt, borderwidth= 2, padx=5, pady=15)
lblframeHistory <- tk2label(frameHistory,text="Commands Window", font=fontTextTitle, foreground= "blue") 
scrtextHistory <- tkscrollbar(frameHistory, orient = "vertical",
                                 command=function(...) tkyview(textHistory, ...))
textHistory <- tktext(frameHistory, height=22, width=90,
                        yscrollcommand=function(...) tkset(scrtextHistory, ...),
                        foreground= "navy", background= "white", state="disabled", wrap="word", font=fontTextWindow)

tkgrid(lblframeHistory)
tkgrid(textHistory,scrtextHistory)
tkgrid.configure(textHistory, pady=c(0,"0.1c"))
tkgrid.configure(scrtextHistory, pady=c(0,"0.1c"), sticky ="nsw")
tkgrid(frameHistory)


frameWarnings <- tkframe(tt, borderwidth=2, padx=5, pady=15)
lblframeWarnings <- tk2label(frameWarnings, text="Warnings Window", font=fontTextTitle, foreground= "blue")    
scrtextWarnings <- tkscrollbar(frameWarnings, orient = "vertical",
                                  command=function(...) tkyview(textWarnings, ...))
textWarnings <- tktext(frameWarnings, height=9, width=90,
                         yscrollcommand=function(...) tkset(scrtextWarnings, ...),
                         foreground= "olivedrab4", background= "white", state="disabled", wrap="word", font=fontTextWindow)
tkgrid(lblframeWarnings)
tkgrid(textWarnings,scrtextWarnings)
tkgrid.configure(scrtextWarnings, pady=c(0,"0.2c"), sticky ="nsw")
tkgrid.configure(textWarnings, pady=c(0,"0.2c"))
tkgrid(frameWarnings)


#######################################################################
### The following text come from:                                   ### 
### http://www.sciviews.org/_rgui/tcltk/Menus.html                  ###
#######################################################################
copyTxt <- function(textBox){

	copyText <- function() tcl("event","generate",.Tk.ID(textBox),"<<Copy>>")
	  
	editPopupMenu <- tkmenu(textBox, tearoff=FALSE)
	tkadd(editPopupMenu, "command", label="Copy <Ctrl-C>", command=copyText)
	  
	RightClick <- function(x,y){ 
	  
		
		rootx <- as.integer(tkwinfo("rootx",textBox))
		rooty <- as.integer(tkwinfo("rooty",textBox))
		xTxt <- as.integer(x)+rootx
		yTxt <- as.integer(y)+rooty
		tcl("tk_popup",editPopupMenu,xTxt,yTxt)
	}
		
	tkbind(textBox, "<Button-3>",RightClick)
}


copyTxt(textHistory)
copyTxt(textWarnings)

copyTxt(textHistory)
copyTxt(textWarnings)


topMenu <- tkmenu(tt)
tkconfigure(tt,menu=topMenu)

fileMenu <- tkmenu(topMenu,tearoff=FALSE)
tkadd(fileMenu,"command",label="Change Directory",command=function() fSetWrkDir(textHistory))
tkadd(fileMenu,"separator")
tkadd(fileMenu,"command",label="Load Workspace", command=function() fLoadWs (functionsMenu, textHistory))
tkadd(fileMenu,"command",label="Save Workspace",command=function() fSaveWs(textHistory))
tkadd(fileMenu,"separator")	
tkadd(fileMenu,"command",label="Save Commands",command=function() fSaveHistory(textHistory))
tkadd(fileMenu,"separator")		
tkadd(fileMenu,"command",label="Exit",command=function() fOnExit(tt, textHistory))

dataMenu <- tkmenu(topMenu,tearoff=FALSE)
  
importdataMenu <- tkmenu(topMenu,tearoff=FALSE)
tkadd(importdataMenu,"command",label="from Text Files",
        command=function() fReadDataSet(textWarnings, functionsMenu, textHistory))

functionsMenu <- tkmenu(topMenu,tearoff=FALSE)
tkadd(functionsMenu,"command",label="Stratification and Selection",command=function() fStratification())

toolsMenu <- tkmenu(topMenu,tearoff=FALSE)
tkadd(toolsMenu,"command",label="Show Datasets",command=function() fshowData())
tkadd(toolsMenu,"command",label="Remove Datasets",
        command=function() fRemoveDataset(functionsMenu,textHistory))

ResultMenu <- tkmenu(topMenu,tearoff=FALSE)
tkadd(ResultMenu,"command",label="Show Results",command=function() fshowResults())
		
HelpMenu <- tkmenu(topMenu,tearoff=FALSE)

tkadd(HelpMenu,"command",label="R Help on FS4",command=function() fOnHelp("FS4"))

tkadd(HelpMenu,"command",label="FS4 2.0 Reference Manual",command=function() browseURL(paste(file.path(path.package(package="FS4")[1], "doc"),
                    "/FS4_2.0ReferenceManual.pdf", sep="")))
tkadd(HelpMenu,"command",label="FS4 2.0 User Guide",command=function() browseURL(paste(file.path(path.package(package="FS4")[1], "doc"),
                    "/FS4_2.0UserGuide.pdf", sep="")))
	
tkadd(topMenu,"cascade",label="File",menu=fileMenu) 

tkadd(topMenu,"cascade",label="Data",menu=dataMenu)
tkadd(dataMenu,"cascade",label="Import Datasets",menu=importdataMenu)
tkadd(dataMenu,"command",label="Export Datasets",command=function() fExportData(textWarnings, textHistory))

tkadd(topMenu,"cascade",label="Functions",menu=functionsMenu)

tkadd(topMenu,"cascade",label="Tools",menu=toolsMenu)

tkadd(topMenu,"cascade",label="Results",menu=ResultMenu)

tkadd(topMenu,"cascade",label="Help",menu=HelpMenu)

tkfocus(tt)


beginsession <- "# FS4 2.0 session start:\n"
tkconfigure(textHistory, state="normal")
tkinsert(textHistory, "end", beginsession)
prstamp <- paste(timestamp(prefix = "# ", suffix = "", quiet = TRUE),"\n")
tkinsert(textHistory, "end", prstamp)
tkinsert(textHistory, "end", "\n")
tkyview.moveto(textHistory, 1.0)
tkconfigure(textHistory, state="disabled")
#   

listDataSets <- function(envir=.GlobalEnv, ...) {
	Objs <- ls(envir = envir, all.names = TRUE)
	if (length(Objs) == 0) return(Objs) 
	names(which(sapply(Objs, function(.x) {is.data.frame(get(.x, envir=envir))})))
}


fOnHelp <- function(x) {
	print(help(x, try.all.packages=TRUE))
}


fSetWrkDir <- function(textHistory){
	WrkDir <- tclvalue(tkchooseDirectory(initialdir=getwd()))
	if (WrkDir != "") {
		setwd(WrkDir)
		commands <- paste('setwd("', WrkDir, '")\n', sep="")
		tkconfigure(textHistory, state="normal")
		tkinsert(textHistory, "end", commands)
		tkinsert(textHistory, "end", "\n")
		tkyview.moveto(textHistory, 1.0)
		tkconfigure(textHistory, state="disabled")
    }
}


fLoadWs <- function(functionsMenu, textHistory){
	RDataFile<-tclvalue(tkgetOpenFile(filetypes='{{R Data Files} {".RData" ".rda"}}'))
	if (nchar(RDataFile)){
		load(RDataFile,envir = .GlobalEnv)
		commands <- paste('load("',RDataFile,'")\n', sep="")
		tkconfigure(textHistory, state="normal")
		tkinsert(textHistory, "end", commands)
		tkinsert(textHistory, "end", "\n")
		tkyview.moveto(textHistory, 1.0)
		tkconfigure(textHistory, state="disabled")
		tkmessageBox(title ="Load Workspace",message = "Operation executed", icon = "info")
		
    }
}


fSaveWs <- function(textHistory){
	saveFile <- tclvalue(tkgetSaveFile(filetypes='{"All Files" {"*"}}',
                     defaultextension="",
					 initialfile=".RData"))
	if (saveFile == "") return()
	obj.names <- ls(envir=.GlobalEnv)
	if (!length(obj.names)){
		tkmessageBox(title="Save Workspace", message="No objects to be saved!", icon="warning")
    }
	else{
		save(list = obj.names, file=saveFile)
		commands <- paste('save(list= ls(), file= "',saveFile,'")\n', sep="")
		tkconfigure(textHistory, state="normal")
		tkinsert(textHistory, "end", commands)
		tkinsert(textHistory, "end", "\n")
		tkyview.moveto(textHistory, 1.0)
		tkconfigure(textHistory, state="disabled")
		tkmessageBox(title ="Save Workspace",message = "Operation executed", icon = "info")
    }
}


fSaveHistory <- function(textSH){
	HistoryFile <- tclvalue(tkgetSaveFile(filetypes="{{Script Files} {.Rhistory}}",
	                                  defaultextension="Rhistory",
                                      initialfile="Stratification"))
	if (HistoryFile != ""){
		script <- tclvalue(tkget(textSH,"1.0", "end"))
		if (script == "\n"){
			tkmessageBox(title="Save Commands", message="No commands to be saved!", icon="warning")
        }
		else{
			HistoryFileW <- file(HistoryFile, "w")
			session <- "## Stratification and Selection session timestamp:\n"
			prstamp <- paste(timestamp(prefix = "## ", suffix = "", quiet = TRUE), "\n")
			script <- paste(script, session, prstamp, sep="")
			cat(script, file = HistoryFileW)
			close(HistoryFileW)
			tkmessageBox(title ="Save Commands", message = "Operation executed", icon = "info")	
        }
    }
}



fOnExit <- function(Ex_tt, textEx){
	SaveWorkspace <-tclvalue(tkmessageBox(title="Save Workspace",
                                      message="Do you want to save the current Workspace?",
                                      icon="question",
                                      type="yesno",
                                      default="yes"))
	if (SaveWorkspace=="yes"){
		fSaveWs(textEx)	
    }
	SaveCommands <-tclvalue(tkmessageBox(title="Save Commands",
                                     message="Do you want to save the Commands History?",
                                     icon="question",
                                     type="yesno",
                                     default="yes"))
	if (SaveCommands=="yes"){
		fSaveHistory(textEx)
    }
	ReturnExit <-tclvalue(tkmessageBox(title="Exit",
                                   message="Are you sure to exit?",
                                   icon="question",
                                   type="yesno",
                                   default="yes"))
	if (ReturnExit=="yes"){
		tkgrab.release(Ex_tt)
		tkdestroy(Ex_tt)
    }
}


fExisting.class <- function(class) {
	any(sapply(ls(.GlobalEnv), function(x)inherits(eval(parse(text=x), envir = .GlobalEnv), class)))
}


fDesignDialog <- function(ttDialog){
#########################################
# Builds a "standard" dialog box: it is #
# modal, not resizable and focused.     #
#########################################
frameGlobal<- tkframe(ttDialog, borderwidth= 2)
tkwm.deiconify(ttDialog)
tkgrab.set(ttDialog)
tkfocus(ttDialog)
tkwm.resizable(ttDialog, 0, 0)
}


MsgErr <- function(message, icon=c("info", "question", "warning", "error"), type=c("okcancel", "yesno", "ok"), title=""){
		return(tkmessageBox(message=message, icon=icon, type=type, title=title))
}


Shot <- function(expr, WarnWindow){
assignTemp("there.are.warnings", FALSE, replace.existing = TRUE)
oldop <- options("warn"=1)
messages.connection <- file(open="w+")
sink(messages.connection, type="message")

on.exit({
	    display.warn(messages.connection, WarnWindow)
        sink(type="message")
        close(messages.connection)
		options(oldop)  
       })

result <- try(expr,TRUE)

if (data.class(result)=="try-error"){
  	tkmessageBox(title="An error has occurred!",message=as.character(result),icon="error",type="ok")
    }

return(result)
}


###########################################
# Functions formatW and display.warn      #
# retrieved from ReGenesees.GUI           #
###########################################
formatW <- function(Wstring){
# Formats a warning string (handling short arglists).                               

# 1) cut the piece involving the invoked Fun...
msgWstring <- unlist(strsplit(as.character(Wstring),":"))
msgFun <- msgWstring[1]
# 2) remove actual arguments (which are not meaningful for the user)...
msgFun <- unlist(strsplit(as.character(msgFun),"\\("))[1]
# 3) the rest is the recomposed Warning description
msgWar <- msgWstring[-1]
msgWar <- paste(msgWar, collapse=":")
if (msgWar != "") c(msgFun, msgWar) else msgFun
}


display.warn <- function(msg.conn, WarnWindow){
##############################################
# Facility for displaying warnings generated #
# when commands are executed trough Shot.    #
##############################################

# First: enable the Warnings Window and clean it...
tkconfigure(WarnWindow, state="normal")
tkdelete(WarnWindow, "1.0", "end")

# Then process the messages stream
msg.lines <- readLines(msg.conn)
warn.lines <- grep("Warning", msg.lines)
nwarn <- nwarn1 <- length(warn.lines)
nml <- nml1 <- length(msg.lines)

# if no warnings have been generated,
# disable the WarnWindow and exit
if (nwarn == 0) {

    tkconfigure(WarnWindow, state="disabled")
    return(invisible(NULL))
    }
	
# Warning have been generated: update flag...
assignTemp("there.are.warnings", TRUE, replace.existing = TRUE)
# ...then write warnings inside the WarnWindow:
# first remove actual arguments (which are not meaningful for the user)
msg.lines2 <- NULL
j.warn <- 1
for (i in 1:nml) {
    if  (i == warn.lines[j.warn]) {
         msg.lines2 <- c(msg.lines2, formatW(msg.lines[i]))
	     if (j.warn < nwarn) j.warn <- j.warn + 1
        }
    else{
         msg.lines2 <- c(msg.lines2, msg.lines[i])
        }
    }

# Recompute "Warning" positions, number and messages lines
warn.lines <- grep("Warning", msg.lines2)
nwarn <- length(warn.lines)
nml <- length(msg.lines2)
# Some checks
if (nwarn > nwarn1) tkmessageBox(title="An error has occurred!", 
                                 message="Warning stream reading failed [1]", 
                                 icon="error", type="ok")
if (nml < nml1) tkmessageBox(title="An error has occurred!", 
                             message="Warning stream reading failed [2]", 
                             icon="error", type="ok")

if (nwarn > 10){
    msg.lines2 <- c(paste(nwarn, "warnings have been generated."),
                          "First and last 5 warnings:",
                          msg.lines2[1:(warn.lines[6]-1)], ". . .", msg.lines2[(warn.lines[nwarn-4]):nml])
    }
message <- paste(msg.lines2, collapse="\n")
tkinsert(WarnWindow, "end", message)
# Now disable the WarnWindow and exit
tkconfigure(WarnWindow, state="disabled")
}


###########################################
# Function fReadDataSet retrieved from    #
# ReGenesees.GUI with some modifications. #        
###########################################
fReadDataSet <- function(WarnWindow, functionsMenu, textHistory){

ttReadDataSet <- tktoplevel()
fDesignDialog(ttReadDataSet)
tkwm.title(ttReadDataSet,"Import data from Text file")
optionsFrame <- tkframe(ttReadDataSet)
optionsLocations <- tkframe(ttReadDataSet)
buttonsFrame <- tkframe(ttReadDataSet)
	
dsname <- tclVar("Dataset")
entryDsname <- ttkentry(optionsFrame, width = "20", textvariable=dsname)
	
headerVariable <- tclVar("1")
headerCheckBox <- ttkcheckbutton(optionsFrame, variable=headerVariable)
	
missingVariable <- tclVar("NA")
missingEntry <- ttkentry(optionsFrame, width="8", textvariable=missingVariable)

###################
# Field Separator #
###################	
rbDelimiterW <- ttkradiobutton(optionsLocations)
rbDelimiterC <- ttkradiobutton(optionsLocations)
rbDelimiterT <- ttkradiobutton(optionsLocations)
rbDelimiterO <- ttkradiobutton(optionsLocations)
			
rbValueDelimiter <- tclVar("whitespace")
	
labelDelimiterW <- ttklabel(optionsLocations,text="  White space", justify="left")
labelDelimiterC <- ttklabel(optionsLocations,text="  Commas", justify="left")
labelDelimiterT <- ttklabel(optionsLocations,text="  Tabs", justify="left")
labelDelimiterO <- ttklabel(optionsLocations,text="  Other", justify="left")
	
labelOtherEntry <- ttklabel(optionsLocations, text="Specify:")
otherVariable <- tclVar("")
OtherEntry <- ttkentry(optionsLocations, width="4", textvariable=otherVariable)
	
# When default delimiter applies, no other can be specified
tkconfigure(OtherEntry, state = "disabled")
	
##########################	
# Decimal-Point Character #
###########################
rbDecimalP <- ttkradiobutton(optionsLocations)
rbDecimalC <- ttkradiobutton(optionsLocations)
	
rbValueDecimal <- tclVar("period")
labelDecimalP <- ttklabel(optionsLocations,text="  Period [.]")
labelDecimalC <- ttklabel(optionsLocations,text="  Comma [,]")
	
	
ok.but <- tk2button(buttonsFrame, text="OK",
                        image=image_ok, compound="left",
                        command=function() fOnRun())
Cancel.but <- tk2button(buttonsFrame, text="Cancel",
                            image=image_cancel, compound="left",
                            command=function() fOnCancel(ttReadDataSet))
FunctionHelp.but <- tk2button(buttonsFrame, text="Function Help ",
                                  image=image_help, compound="left",
                                  command=function() fOnHelp("read.table"))

	
tkgrid(ttklabel(optionsFrame, text="  Enter name for data set:  "), entryDsname, sticky="w", pady=c("0.3c", "0.0c"))
tkgrid(ttklabel(optionsFrame, text="  Variable names in file:   "), headerCheckBox, sticky="w")
tkgrid(ttklabel(optionsFrame, text="  Missing data indicator:   "), missingEntry, sticky="w")
tkgrid(ttklabel(optionsFrame, text="\n"))

tkgrid(ttklabel(optionsLocations, text="  Field Separator  ", foreground= "blue"), sticky="w")
				
tkconfigure(rbDelimiterW, variable=rbValueDelimiter, value="whitespace")
tkconfigure(rbDelimiterC, variable=rbValueDelimiter, value="commas")
tkconfigure(rbDelimiterT, variable=rbValueDelimiter, value="tabs")
tkconfigure(rbDelimiterO, variable=rbValueDelimiter, value="other")

tkbind(rbDelimiterW, "<ButtonPress>", function() {
                                          tkdelete(OtherEntry, 0, "end")
	                                      tkconfigure(OtherEntry, state = "disabled")
										  })
tkbind(rbDelimiterC, "<ButtonPress>", function() {
                                          tkdelete(OtherEntry, 0, "end")
	                                      tkconfigure(OtherEntry, state = "disabled")
										  })
tkbind(rbDelimiterT, "<ButtonPress>", function() {
                                          tkdelete(OtherEntry, 0, "end")
	                                      tkconfigure(OtherEntry, state = "disabled")
										  })
tkbind(rbDelimiterO, "<ButtonPress>", function() tkconfigure(OtherEntry, state = "normal"))

tkgrid(labelDelimiterW, rbDelimiterW, sticky="w")
tkgrid(labelDelimiterC, rbDelimiterC, sticky="w")
tkgrid(labelDelimiterT, rbDelimiterT, sticky="w")
tkgrid(labelDelimiterO, rbDelimiterO, labelOtherEntry, OtherEntry, sticky="w")
tkgrid.configure(labelOtherEntry, column=3)
tkgrid.configure(OtherEntry, column=4, sticky="w")		

tkgrid(ttklabel(optionsLocations, text="\n"))
tkgrid(ttklabel(optionsLocations, text="  Decimal-Point Character  ", foreground= "blue"), sticky="w")
	
tkconfigure(rbDecimalP, variable=rbValueDecimal, value="period")
tkconfigure(rbDecimalC, variable=rbValueDecimal, value="comma")
	
tkgrid(labelDecimalP, rbDecimalP, sticky="w")
tkgrid(labelDecimalC, rbDecimalC, sticky="w")
tkgrid(ttklabel(optionsLocations, text="\n"))				
	
tkgrid(ok.but, Cancel.but, FunctionHelp.but)

tkgrid(optionsFrame)
tkgrid(optionsLocations)
tkgrid(buttonsFrame)
tkgrid.configure(buttonsFrame, padx="0.2c", pady=c("0.0c", "0.3c"))
tkgrid.configure(optionsFrame, sticky="w")
tkgrid.configure(optionsLocations, sticky="w")
			
	fOnRun <- function(){
		dsnameValue <- trim.blanks(tclvalue(tkget(entryDsname)))   
		if(dsnameValue == ""){
			MsgErr("The dataset name is empty", "error", "ok", "read.table")
			return()
		}
		if (!is.valid.name(dsnameValue)) {
			tkmessageBox(title="Data import",
			             message= paste('"', dsnameValue, '" ',"is not a valid name", sep=""),
                         icon="error") 
			return()
		}
				
		if (is.element(dsnameValue, listDataSets())){
			ReturnExit <- tclvalue(tkmessageBox(title="Data import",
			                       message=paste("A Dataset named ", dsnameValue,
					                             " already exists. Do you want to overwrite it?", sep = ""),
			                       icon="question", type="yesno",default="no"))
			if (ReturnExit=="no"){
			    return()
			}
		}	
			
		tkgrab.release(ttReadDataSet)
		tkdestroy(ttReadDataSet)	
			
		File <- tclvalue(tkgetOpenFile(filetypes = "{{Text Files}
			                                            {.txt .TXT .dat .DAT .csv .CSV}} "))
			
		if(File == ""){
			return()
		}
		head <- tclvalue(headerVariable) == "1"
		delimiter <- tclvalue(rbValueDelimiter)
		del <- if (delimiter == "whitespace") ""
			else if (delimiter == "commas") ","
			else if (delimiter == "tabs") "\t"
			else tclvalue(otherVariable)
		miss <- tclvalue(missingVariable)
		dec <- if (tclvalue(rbValueDecimal) == "period") "." else ","
			
# Update to align with R new version (4.0.0): stringsAsFactors = FALSE (default value)		
		valReadDataSet <- Shot(read.table(File, header = head, sep = del, na.strings = miss,
		                                    quote="\"", dec = dec, strip.white = TRUE, comment.char = "", stringsAsFactors = TRUE), WarnWindow)
 
		if (!inherits(valReadDataSet,"try-error")){ 
			assign(dsnameValue, valReadDataSet, envir=.GlobalEnv)
			
            # print on the Commands Window
            del.print <- ifelse(del=="\t", "\\t", del)
# Update to align with R new version (4.0.0): stringsAsFactors = FALSE	(default value)		
			statement <- paste('read.table(file= "', File,'", header= ', head,
			', sep= "', del.print, '", na.strings= ', miss, ', quote="\\\"", dec= "', dec,
			'", strip.white= TRUE, comment.char= "", stringsAsFactors = TRUE)', sep="")
			commands <- paste(dsnameValue, " <- ", statement,"\n", sep="")
			tkconfigure(textHistory, state="normal")
			tkinsert(textHistory, "end", commands)
			tkinsert(textHistory, "end", "\n")
			tkyview.moveto(textHistory, 1.0)
			tkconfigure(textHistory, state="disabled")
				
			tkmessageBox(title ="Import data",message = "Operation executed", icon = "info")
		}
	}
}
	
	
inherits.obj <- function(class) {
#########################################
# Flags objects inheriting from a given #
# class inside the current Workspace.   #
#########################################
sapply(ls(.GlobalEnv), function(x) inherits(eval(parse(text=x), envir = .GlobalEnv), class))
}


###########################################
# Function fshowData retrieved from       # 
# ReGenesees.GUI with some modifications. #
# Actions performed when asking to show   #
# some Datasets in the current Workspace. #
###########################################
fshowData <- function(){
	showit <- function(obj){
		Dataset <- get(obj, envir=.GlobalEnv)
		showDataFS4(Dataset, title=obj)
	}
	selectDataSet(action = showit)
}


fshowResults <- function(){
	showit <- function(obj){
		Dataset <- get(obj, envir=.GlobalEnv)
		showDataFS4(Dataset, title=obj)
	}
	selectResult(action = showit)
}


##################################################
# Function selectDataSet retrieved from          # 
# ReGenesees.GUI with some modifications.        # 
# Build a List Box (with scrollbar) storing the  #
# names of the objects inheriting from classes   #
# data.frame which are found inside              #
# the current Workspace.                         #
# One Dataset is eventually selected and a given #
# action is performed on it.                     # 
##################################################
selectDataSet <- function(action=print, WarnWindow = NULL, ...){ 

obj.names <- ls(.GlobalEnv)

if (length(obj.names)==0) {
    tkmessageBox(title="Available Datasets",
                 message = "No dataset found in the current Workspace!",
                 icon = "warning")
	 return(invisible(NULL))
}

df.obj <- obj.names[inherits.obj("data.frame")]

if  (length(df.obj)==0)  {
    tkmessageBox(title="Available Datasets",
                 message = "No Datasets found in the current Workspace!",
                 icon = "warning")
	return(invisible(NULL))
    }

datasets <- sort(df.obj)

listBox(datasets, title = "Available Datasets",
        label = " Please select a Dataset (only one)", action=action,
        selectmode="single", WarnWindow = WarnWindow, ...)
}


#####################################################
#  Function listBox retrieved from ReGenesees.GUI.  # 
#  List Box (with scrollbar): select one element    #
#  and perform an action on it.                     #
#####################################################
listBox <- function(list, title="",
                    label=" Please select an item from the list (only one)",
                    action=print, selectmode="single", WarnWindow = NULL, ...){

tt <- tktoplevel()
tkwm.title(tt, title)
box <- tkframe(tt)
butts <- tkframe(tt)
scr <- tkscrollbar(box, repeatinterval=5,
                   command=function(...)tkyview(tl,...))
			   
tl <- tklistbox(box, height=10, selectmode=selectmode,
                yscrollcommand=function(...)tkset(scr,...), background="white")
			
for (el in list){
    tkinsert(tl,"end", el)
    }
# Default Dataset is the first of the list
tkselection.set(tl, 0)						
				

tkgrid(tklabel(tt, text = " "))
tkgrid(tklabel(tt, text = label))
tkgrid(tklabel(tt, text = " "))
tkgrid(box)
tkgrid(tl, scr)
tkgrid.configure(tl, sticky="e", padx=c("1c",0))
tkgrid.configure(scr, sticky="nsw", padx=c(0,"1c"))

OnOK <- function(action, WarnWindow, ...) {
	Choice <- list[as.numeric(tkcurselection(tl))+1]
    tkdestroy(tt)
    if ( any(names(formals(action))=="WarnWindow") ) {
        action(Choice, WarnWindow, ...)
        }
    else action(Choice, ...)
    }
OK.but <- tk2button(butts,text="   OK   ", image=image_ok,
                    compound="left", command = function() OnOK(action = action,
                                                               WarnWindow = WarnWindow,
                                                               ...) )
Canc.but <- tk2button(butts,text="Cancel", image=image_cancel,
                      compound="left", command = function() fOnCancel(tt))
tkgrid(butts)
tkgrid.configure(butts, pady=c("0.4c", "0.2c"))
tkgrid(OK.but, Canc.but)
tkfocus(tt)
}

selectResult <- function(action=print, WarnWindow = NULL, ...){ 

obj.names <- ls(.GlobalEnv)

if (length(obj.names)==0) {
    tkmessageBox(title="Available Datasets",
                 message = "No datasets found in the current Workspace!",
                 icon = "warning")
	 return(invisible(NULL))
    }

df.obj <- obj.names[inherits.obj("results")]

if  (length(df.obj)==0)  {
    tkmessageBox(title="Available Results",
                 message = "No Results found in the current Workspace!",
                 icon = "warning")
	return(invisible(NULL))
    }

datasets <- sort(df.obj)

listBox(datasets, title = "Available Results",
        label = " Please select a Dataset Result(only one)", action=action,
        selectmode="single", WarnWindow = WarnWindow, ...)
}


#########################################
#   As function showData (package       #
#   relimp), but with some changes.     #
#########################################
showDataFS4 <-
function (dataframe, colname.bgcolor = "lightskyblue", rowname.bgcolor = "lightskyblue", 
    body.bgcolor = "white", colname.textcolor = "blue", rowname.textcolor = "blue", 
    body.textcolor = "black", font = "Courier 12", maxheight = 30, 
    maxwidth = 80, title = NULL, rowname.bar = "left", colname.bar = "top", 
    rownumbers = FALSE, placement = "-20-40", suppress.X11.warnings = FALSE,
	dim.l = 3e6) 
{
    object.name <- deparse(substitute(dataframe))
   
    if (!is.data.frame(dataframe)) {
# Update to align with R new version (4.0.0): stringsAsFactors = FALSE (default value)			
        temp <- try(dataframe <- as.data.frame(dataframe, stringsAsFactors = TRUE), silent = FALSE)
        if (inherits(temp, "try-error")) {
            stop(paste(object.name, "cannot be coerced to a data frame"))
       }
        object.name <- paste("as.data.frame(", object.name, ")", sep = "")
    }
      if (is.numeric(rownumbers) &&
        length(rownumbers) != nrow(dataframe)) {
        stop("rownumbers argument must be TRUE, FALSE or have length nrow(dataframe)")
    }

    if (prod(dim(dataframe)) > dim.l) {
        return(editFS4(dataframe))
	}
	
    oldwidth <- unlist(options("width"))
    options(width = 10000)
    conn <- file()
    sink(conn)
    print(dataframe)
    sink()
    zz <- scan(conn, sep = "\n", what = character(0), quiet = TRUE)
    close(conn)
    if (length(zz) > 1 + nrow(dataframe))
        return(editFS4(dataframe))
	options(width = oldwidth)
    if (suppress.X11.warnings) {
        messages.connection <- textConnection(".messages", open = "w", 
            local = TRUE)
        sink(messages.connection, type = "message")
        on.exit({
            sink(type = "message")
            close(messages.connection)
        })
    }
    base <- tktoplevel()
    tkwm.geometry(base, placement)
    tkwm.title(base, {
        if (is.null(title))
            object.name
        else title
    })
    nrows <- length(zz) - 1
    if (is.numeric(rownumbers)) 
        rowname.text <- paste(rownumbers, row.names(dataframe))
    else if (rownumbers) 
        rowname.text <- paste(1:nrows, row.names(dataframe))
    else rowname.text <- row.names(dataframe)
    namewidth = max(nchar(rowname.text))
    yy <- substring(zz, 2 + max(nchar(row.names(dataframe))))
    datawidth <- max(nchar(yy))
    winwidth <- min(1 + datawidth, maxwidth)
    hdr <- tktext(base, bg = colname.bgcolor, fg = colname.textcolor, 
        font = font, height = 1, width = winwidth, takefocus = TRUE)
    ftr <- tktext(base, bg = colname.bgcolor, fg = colname.textcolor, 
        font = font, height = 1, width = winwidth, takefocus = TRUE)
    textheight <- min(maxheight, nrows)
    txt <- tktext(base, bg = body.bgcolor, fg = body.textcolor, 
        font = font, height = textheight, width = winwidth, setgrid = 1, 
        takefocus = TRUE)
    lnames <- tktext(base, bg = rowname.bgcolor, fg = rowname.textcolor, 
        font = font, height = textheight, width = namewidth, 
        takefocus = TRUE)
    rnames <- tktext(base, bg = rowname.bgcolor, fg = rowname.textcolor, 
        font = font, height = textheight, width = namewidth, 
        takefocus = TRUE)
    xscroll <- tkscrollbar(base, orient = "horizontal", repeatinterval = 1, 
        command = function(...) {
            tkxview(txt, ...)
            tkxview(hdr, ...)
            tkxview(ftr, ...)
        })
    string.to.vector <- function(string.of.indices) {
        string.of.indices <- tclvalue(string.of.indices)
        as.numeric(strsplit(string.of.indices, split = " ")[[1]])
    }
    tkconfigure(txt, xscrollcommand = function(...) {
        tkset(xscroll, ...)
        xy <- string.to.vector(tkget(xscroll))
        tkxview.moveto(hdr, xy[1])
        tkxview.moveto(ftr, xy[1])
    })
    tkconfigure(hdr, xscrollcommand = function(...) {
        tkset(xscroll, ...)
        xy <- string.to.vector(tkget(xscroll))
        tkxview.moveto(txt, xy[1])
        tkxview.moveto(ftr, xy[1])
    })
    tkconfigure(ftr, xscrollcommand = function(...) {
        tkset(xscroll, ...)
        xy <- string.to.vector(tkget(xscroll))
        tkxview.moveto(hdr, xy[1])
        tkxview.moveto(txt, xy[1])
    })
    yscroll <- tkscrollbar(base, orient = "vertical", repeatinterval = 1, 
        command = function(...) {
            tkyview(txt, ...)
            tkyview(lnames, ...)
            tkyview(rnames, ...)
        })
    tkconfigure(txt, yscrollcommand = function(...) {
        tkset(yscroll, ...)
        xy <- string.to.vector(tkget(yscroll))
        tkyview.moveto(lnames, xy[1])
        tkyview.moveto(rnames, xy[1])
    })
    tkconfigure(lnames, yscrollcommand = function(...) {
        tkset(yscroll, ...)
        xy <- string.to.vector(tkget(yscroll))
        tkyview.moveto(txt, xy[1])
        tkyview.moveto(rnames, xy[1])
    })
    tkconfigure(rnames, yscrollcommand = function(...) {
        tkset(yscroll, ...)
        xy <- string.to.vector(tkget(yscroll))
        tkyview.moveto(txt, xy[1])
        tkyview.moveto(lnames, xy[1])
    })
    tkbind(txt, "<B2-Motion>", function(x, y) {
        tkscan.dragto(txt, x, y)
    })
    {
        copyText.hdr <- function() {
            tcl("event", "generate", .Tk.ID(hdr), "<<Copy>>")
        }
        tkbind(hdr, "<Button-1>", function() tkfocus(hdr))
        editPopupMenu.hdr <- tkmenu(hdr, tearoff = FALSE)
        tkadd(editPopupMenu.hdr, "command", label = "Copy <Ctrl-C>", 
            command = copyText.hdr)
        RightClick.hdr <- function(x, y) {
            rootx <- as.integer(tkwinfo("rootx", hdr))
            rooty <- as.integer(tkwinfo("rooty", hdr))
            xTxt <- as.integer(x) + rootx
            yTxt <- as.integer(y) + rooty
            tcl("tk_popup", editPopupMenu.hdr, xTxt, yTxt)
        }
        tkbind(hdr, "<Button-3>", RightClick.hdr)
        tkbind(hdr, "<Control-KeyPress-c>", copyText.hdr)
        copyText.ftr <- function() {
            tcl("event", "generate", .Tk.ID(ftr), "<<Copy>>")
        }
        tkbind(ftr, "<Button-1>", function() tkfocus(ftr))
        editPopupMenu.ftr <- tkmenu(ftr, tearoff = FALSE)
        tkadd(editPopupMenu.ftr, "command", label = "Copy <Ctrl-C>", 
            command = copyText.ftr)
        RightClick.ftr <- function(x, y) {
            rootx <- as.integer(tkwinfo("rootx", ftr))
            rooty <- as.integer(tkwinfo("rooty", ftr))
            xTxt <- as.integer(x) + rootx
            yTxt <- as.integer(y) + rooty
            tcl("tk_popup", editPopupMenu.ftr, xTxt, yTxt)
        }
        tkbind(ftr, "<Button-3>", RightClick.ftr)
        tkbind(ftr, "<Control-KeyPress-c>", copyText.ftr)
        copyText.txt <- function() {
            tcl("event", "generate", .Tk.ID(txt), "<<Copy>>")
        }
        tkbind(txt, "<Button-1>", function() tkfocus(txt))
        editPopupMenu.txt <- tkmenu(txt, tearoff = FALSE)
        tkadd(editPopupMenu.txt, "command", label = "Copy <Ctrl-C>", 
            command = copyText.txt)
        RightClick.txt <- function(x, y) {
            rootx <- as.integer(tkwinfo("rootx", txt))
            rooty <- as.integer(tkwinfo("rooty", txt))
            xTxt <- as.integer(x) + rootx
            yTxt <- as.integer(y) + rooty
            tcl("tk_popup", editPopupMenu.txt, xTxt, yTxt)
        }
        tkbind(txt, "<Button-3>", RightClick.txt)
        tkbind(txt, "<Control-KeyPress-c>", copyText.txt)
        copyText.lnames <- function() {
            tcl("event", "generate", .Tk.ID(lnames), "<<Copy>>")
        }
        tkbind(lnames, "<Button-1>", function() tkfocus(lnames))
        editPopupMenu.lnames <- tkmenu(lnames, tearoff = FALSE)
        tkadd(editPopupMenu.lnames, "command", label = "Copy <Ctrl-C>", 
            command = copyText.lnames)
        RightClick.lnames <- function(x, y) {
            rootx <- as.integer(tkwinfo("rootx", lnames))
            rooty <- as.integer(tkwinfo("rooty", lnames))
            xTxt <- as.integer(x) + rootx
            yTxt <- as.integer(y) + rooty
            tcl("tk_popup", editPopupMenu.lnames, xTxt, yTxt)
        }
        tkbind(lnames, "<Button-3>", RightClick.lnames)
        tkbind(lnames, "<Control-KeyPress-c>", copyText.lnames)
        copyText.rnames <- function() {
            tcl("event", "generate", .Tk.ID(rnames), "<<Copy>>")
        }
        tkbind(rnames, "<Button-1>", function() tkfocus(rnames))
        editPopupMenu.rnames <- tkmenu(rnames, tearoff = FALSE)
        tkadd(editPopupMenu.rnames, "command", label = "Copy <Ctrl-C>", 
            command = copyText.rnames)
        RightClick.rnames <- function(x, y) {
            rootx <- as.integer(tkwinfo("rootx", rnames))
            rooty <- as.integer(tkwinfo("rooty", rnames))
            xTxt <- as.integer(x) + rootx
            yTxt <- as.integer(y) + rooty
            tcl("tk_popup", editPopupMenu.rnames, xTxt, yTxt)
        }
        tkbind(rnames, "<Button-3>", RightClick.rnames)
        tkbind(rnames, "<Control-KeyPress-c>", copyText.rnames)
    }
    tktag.configure(hdr, "notwrapped", wrap = "none")
    tktag.configure(ftr, "notwrapped", wrap = "none")
    tktag.configure(txt, "notwrapped", wrap = "none")
    tktag.configure(lnames, "notwrapped", wrap = "none")
    tktag.configure(rnames, "notwrapped", wrap = "none")
    tkinsert(txt, "end", paste(paste(yy[-1], collapse = "\n"), 
        sep = ""), "notwrapped")
    tkgrid(txt, row = 1, column = 1, sticky = "nsew")
    if ("top" %in% colname.bar) {
        tkinsert(hdr, "end", paste(yy[1], sep = ""), "notwrapped")
        tkgrid(hdr, row = 0, column = 1, sticky = "ew")
    }
    if ("bottom" %in% colname.bar) {
        tkinsert(ftr, "end", paste(yy[1], sep = ""), "notwrapped")
        tkgrid(ftr, row = 2, column = 1, sticky = "ew")
    }
    if ("left" %in% rowname.bar) {
        tkinsert(lnames, "end", paste(rowname.text, collapse = "\n"), 
            "notwrapped")
        tkgrid(lnames, row = 1, column = 0, sticky = "ns")
    }
    if ("right" %in% rowname.bar) {
        tkinsert(rnames, "end", paste(rowname.text, collapse = "\n"), 
            "notwrapped")
        tkgrid(rnames, row = 1, column = 2, sticky = "ns")
    }
    tkconfigure(txt, state = "disabled")
    tkconfigure(lnames, state = "disabled")
    tkconfigure(rnames, state = "disabled")
    if (maxheight < nrows) {
        tkgrid(yscroll, row = 1, column = 3, sticky = "ns")
    }
    if (maxwidth < datawidth) {
        tkgrid(xscroll, row = 3, column = 1, sticky = "ew")
    }
    tkgrid.rowconfigure(base, 1, weight = 1)
    tkgrid.columnconfigure(base, 1, weight = 1)
    tkwm.maxsize(base, 1 + datawidth, nrows)
    tkwm.minsize(base, 1 + nchar(names(dataframe)[1]), 1)
	tkfocus(base)
    on.exit(
       gc()
    )
    invisible(NULL)
}

fun_edit <- utils::getFromNamespace("edit.data.frame", "utils")

################################################################
# As utils:::edit.data.frame, but with invisible return value. #
################################################################
editFS4 <- function (name, factor.mode = c("character", "numeric"), 
                    edit.row.names = any(row.names(name) != 1L:nrow(name)), ...)

{
		invisible(fun_edit(name = name, factor.mode = factor.mode, edit.row.names = edit.row.names, ...))

}


###############################################
# Utility functions used by fReadDataSet, all #
# retrieved from Rcmdr:                       #
# - trim.blanks                               #
# - is.valid.name                             #
###############################################

trim.blanks <- function(text){
    gsub("^\ *", "", gsub("\ *$", "", text))
}

is.valid.name <- function(x){
    length(x) == 1 && is.character(x) && x == make.names(x)
}

fExportData <- function(WarnWindow, textHistory){
#############################################
# Actions performed when asking to export   #
# some Datasets from the current Workspace. #
#############################################
selectDataSet(action = exportDataSet,
              WarnWindow = WarnWindow, textHistory = textHistory) 
}


#############################################
# Function exportDataSet retrieved from     # 
# ReGenesees.GUI with some modifications.   #
# Actions performed when asking to export   #
# some Datasets from the current Workspace. #
#############################################
exportDataSet <- function(dsname, WarnWindow, textHistory) {

ttExpDataSet <- tktoplevel()
fDesignDialog(ttExpDataSet)
tkwm.title(ttExpDataSet,"Export selected Dataset")
optionsFrame <- tkframe(ttExpDataSet)
optionsLocations <- tkframe(ttExpDataSet)
buttonsFrame <- tkframe(ttExpDataSet)
	
# col.names
colnamesVariable <- tclVar("1")
colnamesCheckBox <- ttkcheckbutton(optionsFrame, variable=colnamesVariable)
	
# row.names
rownamesVariable <- tclVar("0")
rownamesCheckBox <- ttkcheckbutton(optionsFrame, variable=rownamesVariable)
	
# quote
quotesVariable <- tclVar("0")
quotesCheckBox <- ttkcheckbutton(optionsFrame, variable=quotesVariable)

# NA
missingVariable <- tclVar("NA")
missingEntry <- ttkentry(optionsFrame, width="8", textvariable=missingVariable)

# Field Separator 
rbDelimiterW <- ttkradiobutton(optionsLocations)
rbDelimiterC <- ttkradiobutton(optionsLocations)
rbDelimiterT <- ttkradiobutton(optionsLocations)
rbDelimiterO <- ttkradiobutton(optionsLocations)
			
rbValueDelimiter <- tclVar("spaces")
	
labelDelimiterW <- ttklabel(optionsLocations,text="  Spaces", justify="left")
labelDelimiterC <- ttklabel(optionsLocations,text="  Commas", justify="left")
labelDelimiterT <- ttklabel(optionsLocations,text="  Tabs", justify="left")
labelDelimiterO <- ttklabel(optionsLocations,text="  Other", justify="left")
	
labelOtherEntry <- ttklabel(optionsLocations, text="Specify:")
otherVariable <- tclVar("")
OtherEntry <- ttkentry(optionsLocations, width="4", textvariable=otherVariable)

# When default delimiter applies, no other can be specified	
tkconfigure(OtherEntry, state = "disabled")

# Create Buttons	
ok.but <- tk2button(buttonsFrame, text="OK",
                        image=image_ok, compound="left",
   	                    command=function(...) fOnRun(...))
Cancel.but <- tk2button(buttonsFrame, text="Cancel",
                            image=image_cancel, compound="left",
                            command=function() fOnCancel(ttExpDataSet))
FunctionHelp.but <- tk2button(buttonsFrame, text="Function Help",
                                  image=image_help, compound="left",
                                  command=function() fOnHelp("write.table"))

tkgrid(ttklabel(optionsFrame, text="\n"))
tkgrid(ttklabel(optionsFrame, text="  Write variable names:   "), colnamesCheckBox, sticky="w")
tkgrid(ttklabel(optionsFrame, text="  Write row names:   "), rownamesCheckBox, sticky="w")
tkgrid(ttklabel(optionsFrame, text="  Quotes around character values:   "), quotesCheckBox, sticky="w")
tkgrid(ttklabel(optionsFrame, text="\n"))
	
tkgrid(ttklabel(optionsLocations, text="  Field Separator  ", foreground= "blue"), sticky="w")
				
tkconfigure(rbDelimiterW, variable=rbValueDelimiter, value="spaces")
tkconfigure(rbDelimiterC, variable=rbValueDelimiter, value="commas")
tkconfigure(rbDelimiterT, variable=rbValueDelimiter, value="tabs")
tkconfigure(rbDelimiterO, variable=rbValueDelimiter, value="other")
	
tkbind(rbDelimiterW, "<ButtonPress>", function() {
                                          tkdelete(OtherEntry, 0, "end")
	                                      tkconfigure(OtherEntry, state = "disabled")
										  })
tkbind(rbDelimiterC, "<ButtonPress>", function() {
                                          tkdelete(OtherEntry, 0, "end")
	                                      tkconfigure(OtherEntry, state = "disabled")
										  })
tkbind(rbDelimiterT, "<ButtonPress>", function() {
                                          tkdelete(OtherEntry, 0, "end")
	                                      tkconfigure(OtherEntry, state = "disabled")
										  })
tkbind(rbDelimiterO, "<ButtonPress>", function() tkconfigure(OtherEntry, state = "normal"))
	
tkgrid(labelDelimiterW, rbDelimiterW, sticky="w")
tkgrid(labelDelimiterC, rbDelimiterC, sticky="w")
tkgrid(labelDelimiterT, rbDelimiterT, sticky="w")
tkgrid(labelDelimiterO, rbDelimiterO, labelOtherEntry, OtherEntry, sticky="w")
tkgrid.configure(labelOtherEntry, column=3)
tkgrid.configure(OtherEntry, column=4, sticky="w")
	
tkgrid(tklabel(buttonsFrame, text= "\n"))
tkgrid(ok.but, Cancel.but, FunctionHelp.but)
	
tkgrid(optionsFrame)
tkgrid(optionsLocations)

tkgrid.configure(buttonsFrame, padx="0.2c", pady=c("0.0c", "0.3c"))
tkgrid.configure(optionsFrame, sticky="w")
tkgrid.configure(optionsLocations, sticky="w")
			
	fOnRun <- function(...){
		tkgrab.release(ttExpDataSet)
		tkdestroy(ttExpDataSet)
		col <- tclvalue(colnamesVariable) == 1
		row <- tclvalue(rownamesVariable) == 1
        if (row && col) col <- NA
       	quote <- tclvalue(quotesVariable) == 1
		missing <- tclvalue(missingVariable)
		delim <- tclvalue(rbValueDelimiter)
		sep <- if (delim == "tabs") "\\t"
			else if (delim == "spaces") " "
			else if (delim == "commas") ","
			else trim.blanks(tclvalue(otherVariable))

															  
		saveFile <- tclvalue(tkgetSaveFile(filetypes='{"Text Files" {".txt" ".TXT" ".dat" ".DAT" ".csv" ".CSV"}}
                                                     {"All Files" {"*"}}',
										   defaultextension="txt", initialfile=paste(dsname, ".txt", sep="")))											  
		if (saveFile == "") {
			return()
		}
		                    
		
		command <- paste("write.table(", dsname, ', file= "', saveFile, '", sep= "', sep,
			                       '", col.names= ', col, ", row.names= ", row, ", quote= ", quote,
			                       ', na= "', missing, '")', sep="")  
      	  
		exported <- Shot(eval(parse(text = command)), WarnWindow)
		
		if (!inherits(exported,"try-error")){
			 # print on the Commands Window
			tkconfigure(textHistory, state="normal")
			tkinsert(textHistory, "end", paste(command, "\n", sep=""))
			tkinsert(textHistory, "end", "\n")
			tkyview.moveto(textHistory, 1.0)
			tkconfigure(textHistory, state="disabled")
		    tkmessageBox(title ="Export data",message = "Operation executed", icon = "info")
			          
		}	
	}
}


fRemoveDataset <- function(functionsMenu, textHistory){
remdatas <- function(datas){
		plural <- length(datas) > 1
		if (plural) {
			msg <- "Do you really want to remove datasets: "
		}
		else {
			msg <- "Do you really want to remove dataset: "
		}
		ans <- tclvalue(tkmessageBox(title="Remove Datasets",
                              message=paste(msg, paste(datas, collapse=", "), "?", sep=""),
                              icon="question",
                              type="yesno",
                              default="yes"))
		if (ans=="yes"){
			rm(list=datas, envir=.GlobalEnv)
			
			command <- paste("rm(",paste(datas,collapse=", ",sep=""),")\n", sep="")
			tkconfigure(textHistory, state="normal")
			tkinsert(textHistory, "end", command)
			tkinsert(textHistory, "end", "\n")
			tkyview.moveto(textHistory, 1.0)
			tkconfigure(textHistory, state="disabled")	
				
			tkmessageBox(title ="Remove Datasets", message = "Operation executed", icon = "info")
			}
		else{
			selectDataframe(action = remdatas, selectmode="extended")
		}
	}
	selectDataframe(action = remdatas, selectmode="extended")
}


selectDataframe <- function(action=print, selectmode, ...){
allobj <- ls(.GlobalEnv)
	if (length(allobj)==0) {
		tkmessageBox(title="Remove datasets",
					 message = "No datasets found in the current Workspace!", icon = "warning")
		return(invisible(NULL))
		}
	df <- allobj[inherits.obj("data.frame")]
			
	datasets <- sort(df)

	listBox(datasets, title = "Remove datasets",
			label = " Please select one or more datasets to be deleted",
			action=action, selectmode=selectmode, ...)
}

		
fStratification <- function(){

	if (!fExisting.class("data.frame")){ 
	   tkmessageBox(title="Active functions", message = "No function available for the current workspace objects!",
		icon = "warning")
	}
	else{
		listaDataF <- listDataSets()
		ttStratification <- tktoplevel()
		tcl("wm", "protocol", ttStratification, "WM_DELETE_WINDOW", function() fOnCancel(ttStratification))
			
		frameGlobal<- tkframe(ttStratification, borderwidth= 2)
		tkwm.deiconify(ttStratification)
		tkgrab.set(ttStratification)
		tkfocus(ttStratification)
		tkwm.title(ttStratification,"Stratification and Selection")
		tkwm.resizable(ttStratification, 0, 0)
		frameGlobalFileFirst <- tkframe(frameGlobal, relief="groove", borderwidth=2, padx=5, pady=c("0.2c","0.4c"))
		frameTop<- tkframe(frameGlobalFileFirst, relief="groove", borderwidth=2)
		frameFileFirst <- tkframe(frameGlobalFileFirst, relief="groove", borderwidth=2)
		frameCentralTop<- tkframe(frameFileFirst)
		frameCentralDown<- tkframe(frameFileFirst)
		frameGlobalFileAll <- tkframe(frameGlobal, relief="groove", borderwidth=2, padx=5, pady=c("0.2c","0.4c"))
		frameTopFileAll <- tkframe(frameGlobalFileAll, relief="groove", borderwidth=2)
		frameFileAll <- tkframe(frameGlobalFileAll, relief="groove", borderwidth=2)
		frameLaunch  <- tkframe(frameGlobal, borderwidth=0)
		frameOutput  <- tkframe(frameGlobal, borderwidth=0)
		
		frameButtons<- tkframe(frameGlobal, borderwidth=0, padx=5, pady=15)
			
		lblData<- tk2label(frameGlobal,text="Population data file", font=fontTextTitle, foreground= "blue")
		lblAllData<- tk2label(frameGlobal,text="Allocation data file", font=fontTextTitle, foreground= "blue")
			
		lista <- tclVar()
		tclObj(lista) <- listaDataF
		
		lstDataFrame <- tklistbox(frameTop,height = 4, listvariable= lista, selectmode="single", yscrollcommand = function (...)tkset(scrDataSets,...), background = "white")
		scrDataSets <- tk2scrollbar(frameTop, orientation = "vertical", command = function(...) tkyview(lstDataFrame,...)) 
			
		listaVariables <- tclVar()	
		lstVariables <- tklistbox(frameTop,height = 4, listvariable= listaVariables, selectmode="single", yscrollcommand = function (...)tkset(scrVariables,...), background = "white")
		scrVariables<- tk2scrollbar(frameTop, orientation = "vertical", command = function(...) tkyview(lstVariables,...)) 
		
		
		lblfDataSet<- tk2labelframe(frameTop)
			
		count <<- FALSE
		
		tkbind(lstDataFrame, "<ButtonRelease-1>", function() fListFields(lista, lstDataFrame, lblVariables, listaVariables, lstVariables, scrVariables, lblSnpDataframe, 
		ID_PSU.but, ID_PSU.ri.but, Domain.but, Domain.ri.but, Final_Population.but, Final_Population.ri.but, Size.but, Size.ri.but,
		lstID_PSU, lstDomain, lstFinal_Population, lstSize, entry.PSUsamplestr, entry.Min_sample))
		
			
		lblDataframe <- ttklabel(frameTop, text="Select a dataframe", font=fontTextLabel)
		lblVariables <- tklabel(frameTop, font=fontTextLabel, state= "disabled")
		
		lblSnpDataframe <- ttklabel(frameTop,textvariable=as.character(tclvalue(VarScelta_DataFrame)),foreground="red")
																						
		labellblfID_PSU <- tk2label(frameCentralTop,text="ID PSU  ", font=fontTextLabel, image=image_help, compound="right")
		tk2tip(labellblfID_PSU,"Primary sample units identifier")
		lblfID_PSU<- tk2labelframe(frameCentralTop, labelwidget= labellblfID_PSU) 
		
		frameID_PSU <- tkframe(lblfID_PSU, borderwidth=0)
		frameID_PSU.but <- tkframe(lblfID_PSU, borderwidth=0)
		frameID_PSU.ri.but <- tkframe(lblfID_PSU, borderwidth=0)
		
		listaID_PSU <- tclVar()
		lstID_PSU <- tk2listbox(frameID_PSU, height=2, listvariable=listaID_PSU, scroll = "none") 	
		ID_PSU.but <- tk2button(frameID_PSU.but, image=image_sx, state= "disabled", command = function()fMove(lstID_PSU, lstVariables, listaVariables))
		ID_PSU.ri.but <- tk2button(frameID_PSU.ri.but, image=image_dx, state= "disabled", command = function()fRemove(lstID_PSU, lstVariables, listaID_PSU))
		
		###############################
		
		labellblfDomain <- tk2label(frameCentralTop,text="Domain  ", font=fontTextLabel, image=image_help, compound="right")
		tk2tip(labellblfDomain,"Domain membership")		
		lblfDomain<- tk2labelframe(frameCentralTop, labelwidget= labellblfDomain) 
		
		frameDomain <- tkframe(lblfDomain, borderwidth=0)
		frameDomain.but <- tkframe(lblfDomain, borderwidth=0)
		frameDomain.ri.but <- tkframe(lblfDomain, borderwidth=0)
		
		listaDomain <- tclVar()
		lstDomain <- tk2listbox(frameDomain, height=2, listvariable=listaDomain, scroll = "none")
				
		Domain.but <- tk2button(frameDomain.but, image=image_sx, state= "disabled", command = function()fMove(lstDomain, lstVariables, listaVariables))
		Domain.ri.but <- tk2button(frameDomain.ri.but, image=image_dx, state= "disabled", command = function()fRemove(lstDomain, lstVariables, listaDomain))
		###############################
		
		labellblfFinal_Population <- tk2label(frameCentralDown,text="Final Population  ", font=fontTextLabel, image=image_help, compound="right")
		tk2tip(labellblfFinal_Population,"Secondary stage units")			
		lblfFinal_Population<- tk2labelframe(frameCentralDown, labelwidget= labellblfFinal_Population) 
		
		frameFinal_Population <- tkframe(lblfFinal_Population, borderwidth=0)
		frameFinal_Population.but <- tkframe(lblfFinal_Population, borderwidth=0)
		frameFinal_Population.ri.but <- tkframe(lblfFinal_Population, borderwidth=0)
		
		listaFinal_Population <- tclVar()
		lstFinal_Population <- tk2listbox(frameFinal_Population, height=2, listvariable=listaFinal_Population, scroll = "none")
		
		Final_Population.but <- tk2button(frameFinal_Population.but, image=image_sx, state= "disabled", command = function()fMove(lstFinal_Population, lstVariables, listaVariables))
		Final_Population.ri.but <- tk2button(frameFinal_Population.ri.but, image=image_dx, state= "disabled", command = function()fRemove(lstFinal_Population, lstVariables, listaFinal_Population))
		
		#############################################
		
		labellblfSize <- tk2label(frameCentralDown,text="Size PSU  ", font=fontTextLabel, image=image_help, compound="right")
		tk2tip(labellblfSize,"First stage units dimension")		
		lblfSize<- tk2labelframe(frameCentralDown, labelwidget= labellblfSize) 
		
		frameSize <- tkframe(lblfSize, borderwidth=0)
		frameSize.but <- tkframe(lblfSize, borderwidth=0)
		frameSize.ri.but <- tkframe(lblfSize, borderwidth=0)		
		
		listaSize <- tclVar()
		lstSize <- tk2listbox(frameSize, height=2, listvariable=listaSize, scroll = "none")
		
		Size.but <- tk2button(frameSize.but, image=image_sx, state= "disabled", command = function()fMove(lstSize, lstVariables, listaVariables))
		Size.ri.but <- tk2button(frameSize.ri.but, image=image_dx, state= "disabled", command = function()fRemove(lstSize, lstVariables, listaSize))
		
		###############################################
		
		labellblfFinal_sample <- tk2label(frameFileAll,text="Final sample  ", font=fontTextLabel, image=image_help, compound="right")
		tk2tip(labellblfFinal_sample,"Final sample units")		
		lblfFinal_sample<- tk2labelframe(frameFileAll, labelwidget= labellblfFinal_sample) 
		
		frameFinal_sample <- tkframe(lblfFinal_sample, borderwidth=0)
		frameFinal_sample.but <- tkframe(lblfFinal_sample, borderwidth=0)
		frameFinal_sample.ri.but <- tkframe(lblfFinal_sample, borderwidth=0)
		
		listaFinal_sample <- tclVar()
		lstFinal_sample <- tk2listbox(frameFinal_sample, height=2, listvariable=listaFinal_sample, scroll = "none")
		
		Final_sample.but <- tk2button(frameFinal_sample.but, image=image_sx, state= "disabled", command = function()fMove(lstFinal_sample, lstAllVariables, listaAllVariables))
		Final_sample.ri.but <- tk2button(frameFinal_sample.ri.but, image=image_dx, state= "disabled", command = function()fRemove(lstFinal_sample, lstAllVariables, listaFinal_sample))
		
		################################
		
		labellblfAllDomain <- tk2label(frameFileAll,text="Domain  ", font=fontTextLabel, image=image_help,  compound="right")
		tk2tip(labellblfAllDomain,"Domain membership")
		lblfAllDomain<- tk2labelframe(frameFileAll, labelwidget= labellblfAllDomain) 
		
		frameAllDomain <- tkframe(lblfAllDomain, borderwidth=0)
		frameAllDomain.but <- tkframe(lblfAllDomain, borderwidth=0)
		frameAllDomain.ri.but <- tkframe(lblfAllDomain, borderwidth=0)
				
		listaAllDomain <- tclVar()
		lstAllDomain <- tk2listbox(frameAllDomain, height=2, listvariable=listaAllDomain, scroll = "none")
				
		AllDomain.but <- tk2button(frameAllDomain.but, image=image_sx, state= "disabled", command = function()fMove(lstAllDomain, lstAllVariables, listaAllVariables))
		AllDomain.ri.but <- tk2button(frameAllDomain.ri.but, image=image_dx, state= "disabled", command = function()fRemove(lstAllDomain, lstAllVariables, listaAllDomain))
		
		labellblfplanned_min_sample <- tk2label(frameFileAll,text="Planned min sample  ", font=fontTextLabel, image=image_help,compound="right")
		tk2tip(labellblfplanned_min_sample,"Planned secondary sample units to \nobserve in each PSU, variable between domains")		
		lblfplanned_min_sample<- tk2labelframe(frameFileAll, labelwidget= labellblfplanned_min_sample) 
		
		frameplanned_min_sample <- tkframe(lblfplanned_min_sample, borderwidth=0)
		frameplanned_min_sample.but <- tkframe(lblfplanned_min_sample, borderwidth=0)
		frameplanned_min_sample.ri.but <- tkframe(lblfplanned_min_sample, borderwidth=0)
			
		listaplanned_min_sample <- tclVar()
		lstplanned_min_sample <- tk2listbox(frameplanned_min_sample, height=2, listvariable=listaplanned_min_sample, scroll = "none")
				
		planned_min_sample.but <- tk2button(frameplanned_min_sample.but, image=image_sx, state= "disabled", command = function()fMove(lstplanned_min_sample, lstAllVariables, listaAllVariables))
		planned_min_sample.ri.but <- tk2button(frameplanned_min_sample.ri.but, image=image_dx, state= "disabled", command = function()fRemove(lstplanned_min_sample, lstAllVariables, listaplanned_min_sample))
		##############################################
		
		labellblfPSUsamplestr <- tk2label(frameCentralDown,text="PSU stratum", font=fontTextLabel, image=image_help, compound="right")
		tk2tip(labellblfPSUsamplestr,"Number of primary sample units \nto select for each stratum")	 
		lblfPSUsamplestr<- tk2labelframe(frameCentralDown, labelwidget=labellblfPSUsamplestr)
						
		PSUsamplestr <- tclVar(2)  
		entry.PSUsamplestr <-ttkentry(lblfPSUsamplestr,width="4",textvariable=PSUsamplestr, font=fontTextEntry, state= "disabled")
		
		################################
		labellblfMin_sample <- tk2label(frameCentralDown,text="Min sample", font=fontTextLabel, image=image_help, compound="right")
		tk2tip(labellblfMin_sample,"Number of final sample units \nto observe in each PSU")	
		lblfMin_sample<- tk2labelframe(frameCentralDown, labelwidget=labellblfMin_sample)
						
		Min_sample <- tclVar()  
		entry.Min_sample <-ttkentry(lblfMin_sample,width="4",textvariable=Min_sample, font=fontTextEntry, state= "disabled")
			
		###############################################################################################
			
		scrAllDataSets <- tk2scrollbar(frameTopFileAll, orientation = "vertical", command = function(...) tkyview(lstAllDataFrame,...)) 
		Alllista <- tclVar()
		tclObj(Alllista) <- listaDataF
		lstAllDataFrame <- tklistbox(frameTopFileAll,height = 4, listvariable= Alllista, selectmode="single", yscrollcommand = function (...)tkset(scrAllDataSets,...), background = "white")
		
		scrAllVariables<- tk2scrollbar(frameTopFileAll, orientation = "vertical", command = function(...) tkyview(lstAllVariables,...)) 
		listaAllVariables <- tclVar()	
		lstAllVariables <- tklistbox(frameTopFileAll,height = 4, listvariable= listaAllVariables, selectmode="single", yscrollcommand = function (...)tkset(scrAllVariables,...), background = "white")
		
		lblfAllDataSet<- tk2labelframe(frameTopFileAll)
		
		Min_sample_index <<- FALSE
		countAll <<- FALSE
		
		tkbind(lstAllDataFrame, "<ButtonRelease-1>", function() fAllListFields(Min_sample, Alllista, lstAllDataFrame, lblAllVariables, listaAllVariables, lstAllVariables, scrAllVariables, lblSnpAllDataframe, 
		AllDomain.but, AllDomain.ri.but, Final_sample.but, Final_sample.ri.but, planned_min_sample.but, planned_min_sample.ri.but, lblfplanned_min_sample, lstFinal_sample, lstAllDomain,
		lstplanned_min_sample, frameplanned_min_sample.but, frameplanned_min_sample.ri.but, frameplanned_min_sample, entry.Min_sample, ok.but))
		
			
		lblAllDataframe <- ttklabel(frameTopFileAll, text="Select a dataframe", font=fontTextLabel)
		lblAllVariables <- tklabel(frameTopFileAll, font=fontTextLabel, state= "disabled")
		
		lblSnpAllDataframe <- ttklabel(frameTopFileAll,textvariable=as.character(tclvalue(VarScelta_DF_All)),foreground="red")
								
		###########################################################################################################
		labellblfLaunch <- ttklabel(frameLaunch,text="  Partial Launch  ", font=fontTextTitle, foreground= "blue")
		lblfLaunch <- ttklabelframe(frameLaunch, labelwidget = labellblfLaunch)
			
		rbLaunchF <- ttkradiobutton(lblfLaunch)
		rbLaunchT <- ttkradiobutton(lblfLaunch)
		rbValueLaunch <- tclVar("TRUE")

		tkconfigure(rbLaunchF, variable=rbValueLaunch, value="FALSE")
		tkconfigure(rbLaunchT, variable=rbValueLaunch, value="TRUE")

		labelLaunchF <- ttklabel(lblfLaunch,text="No ")
		labelLaunchT <- ttklabel(lblfLaunch,text="Yes ")
		
		
		tkbind(rbLaunchF, "<ButtonPress>", function(){
				tkconfigure(entry.ObjectName, state = "normal")
				tkconfigure(entry.ObjectNameRes1, state = "normal")
				tkconfigure(entry.ObjectNameRes2, state = "normal")
				tkconfigure(entry.ObjectNameRes3, state = "normal")
		})
														
		tkbind(rbLaunchT, "<ButtonPress>", function(){ 
				tkdelete(entry.ObjectName, 0, "end")
				tkdelete(entry.ObjectNameRes2, 0, "end")
				tkdelete(entry.ObjectNameRes3, 0, "end")
				tkconfigure(entry.ObjectName, state = "disabled")
				tkconfigure(entry.ObjectNameRes2, state = "disabled")
				tkconfigure(entry.ObjectNameRes3, state = "disabled")
		})
						
		#######################################################################################################################
			
		labellblfOutputObj <- tk2label(frameOutput,text="  Output data frames name  ", font=fontTextTitle, foreground= "blue")
		lblfOutputObj <- ttklabelframe(frameOutput, labelwidget = labellblfOutputObj)
		
		lblObjectNameRes1 <- tk2label(lblfOutputObj, text="Domain results 1", font=fontTextLabel, image=image_help, compound="right",
		tip="Domain level output before the stratification \nof the whole NSR PSU")
		ObjectNameRes1 <- tclVar("")
		entry.ObjectNameRes1 <- ttkentry(lblfOutputObj,width="20",text=ObjectNameRes1, font=fontTextEntry, state= "normal")
		
		lblObjectNameRes2 <- tk2label(lblfOutputObj, text="Domain results 2", font=fontTextLabel, image=image_help, compound="right",
		tip="Domain level output after the stratification")
		ObjectNameRes2 <- tclVar("")
		entry.ObjectNameRes2 <- ttkentry(lblfOutputObj,width="20",text=ObjectNameRes2, font=fontTextEntry, state= "disabled")
		
		lblObjectNameRes3 <- tk2label(lblfOutputObj, text="Stratum results", font=fontTextLabel, image=image_help, compound="right",
		tip="Stratum level output")
		ObjectNameRes3 <- tclVar("")
		entry.ObjectNameRes3 <- ttkentry(lblfOutputObj,width="20",text=ObjectNameRes3, font=fontTextEntry, state= "disabled")
		
		lblObjectName <- tk2label(lblfOutputObj, text="Final results", font=fontTextLabel, , image=image_help, compound="right",
		tip="PSU level final output")
		ObjectName <- tclVar("")
		entry.ObjectName <- ttkentry(lblfOutputObj,width="20",text=ObjectName, font=fontTextEntry, state= "disabled")

		###################################################################
		
		ok.but <- tk2button(frameButtons, text="OK", image=image_ok, compound="left", state= "disabled",
					command=function() fOnRun(lstID_PSU, lstDomain, lstFinal_Population, lstFinal_sample, lstSize, lstAllDomain, 
					entry.PSUsamplestr, entry.Min_sample, lstplanned_min_sample, rbValueLaunch, ObjectNameRes1, ObjectNameRes2, 
					ObjectNameRes3, ObjectName, ttStratification))
				
									 
		Cancel.but <- tk2button(frameButtons,text="Cancel", image=image_cancel, compound="left",
							command=function() fOnCancel(ttStratification))
		
		FunctionHelp.but <- tk2button(frameButtons,text="Function Help", image=image_help, compound="left",
								  tip=descFun("Description function Stratification and Selection"), command=function() fOnHelp(label_StratSel))
								  
								  
		tkgrid(lblfDataSet)
		tkgrid(lblDataframe, lblVariables)
		
		tkgrid(lblSnpDataframe)
		tkgrid(lstDataFrame, scrDataSets)
		
		tkgrid.configure(lblDataframe, column=1, sticky ="e")
		
		tkgrid.configure(lblSnpDataframe, row=2, column=1)
		tkgrid.configure(lblVariables, column=4)

		tkgrid.configure(lstDataFrame, column=1, row=3, sticky ="e", padx=c("1.7c","0c"), pady=c(0,"0.2c"))
			
		tkgrid.configure(scrDataSets, column=2, row=3, sticky ="nsw", padx=c(0,"1.9c"), pady=c(0,"0.2c"))	
			
		######################################
		tkgrid(lblfID_PSU, lblfDomain)
		
		tkgrid(lblfFinal_Population, lblfSize, lblfPSUsamplestr, lblfMin_sample)
		
		tkgrid(lblfAllDataSet)
		tkgrid(lblAllDataframe, lblAllVariables)
		
		tkgrid(lblSnpAllDataframe)
		tkgrid(lstAllDataFrame, scrAllDataSets)
		
		tkgrid.configure(lblAllDataframe, column=1, sticky ="e")
		tkgrid.configure(lblSnpAllDataframe, row=2, column=1)
		tkgrid.configure(lblAllVariables, column=4)

		tkgrid.configure(lstAllDataFrame, column=1, row=3, sticky ="e", padx=c("1.7c","0c"), pady=c(0,"0.2c"))
		tkgrid.configure(scrAllDataSets, column=2, row=3, sticky ="nsw", padx=c(0,"1.9c"), pady=c(0,"0.2c"))	

		tkgrid(lblfFinal_sample, lblfAllDomain, lblfplanned_min_sample)  
		
		#######################################################################
		tkgrid.configure(lblfID_PSU,padx=c("0.5c",0), pady=c(0,"0.2c"))
		tkgrid.configure(lblfDomain,padx=c("1c",0), pady=c(0,"0.2c"))
		tkgrid.configure(lblfFinal_Population,padx=c("0.5c",0), pady=c(0,"0.2c"))
		
		tkgrid.configure(lblfSize,padx=c("0.5c","0.5c"), pady=c(0,"0.2c"))
		tkgrid.configure(lblfPSUsamplestr,padx=c(0,"0.5c"), pady=c(0,"0.2c"))
		tkgrid.configure(lblfMin_sample,padx=c(0,"0.5c"), pady=c(0,"0.2c"))

		tkgrid.configure(lblfFinal_sample,padx=c("0.3c",0), pady=c(0,"0.2c"))
		tkgrid.configure(lblfAllDomain,padx=c("0.5c","0.5c"), pady=c(0,"0.2c"))
		
		#############################################################	
		tkgrid(frameID_PSU.but, frameID_PSU, frameID_PSU.ri.but)
		tkgrid.configure(frameID_PSU.but, padx= c("0.1c"), pady=c("0.2c","0.2c"))
		tkgrid.configure(frameID_PSU, padx= c(0,"0.1c"), pady=c(0,"0.1c"))
		tkgrid.configure(frameID_PSU.ri.but, padx= c("0.1c"), pady=c(0,"0.4c"))
		tkgrid(ID_PSU.but)
		tkgrid(ID_PSU.ri.but)  
		tkgrid(lstID_PSU) 
		
		tkgrid.configure(ID_PSU.but, pady=c(0,"0.2c"))
		tkgrid.configure(ID_PSU.ri.but, pady=c("0.2c",0))
		
		###########################################
		tkgrid(frameDomain.but, frameDomain, frameDomain.ri.but)
		tkgrid.configure(frameDomain.but, padx= c("0.1c"), pady=c("0.2c","0.2c"))
		tkgrid.configure(frameDomain, padx= c(0,"0.1c"), pady=c(0,"0.1c"))
		tkgrid.configure(frameDomain.ri.but, padx= c("0.1c"), pady=c(0,"0.4c"))
		tkgrid(Domain.but)
		tkgrid(Domain.ri.but)  
		tkgrid(lstDomain) 
		
		tkgrid.configure(Domain.but, pady=c(0,"0.2c"))
		tkgrid.configure(Domain.ri.but, pady=c("0.2c",0))
		
		############################################
		tkgrid(frameFinal_Population.but, frameFinal_Population, frameFinal_Population.ri.but)
		tkgrid.configure(frameFinal_Population.but, padx= c("0.1c"), pady=c("0.2c","0.2c"))
		tkgrid.configure(frameFinal_Population, padx= c(0,"0.1c"), pady=c(0,"0.1c"))
		tkgrid.configure(frameFinal_Population.ri.but, padx= c("0.1c"), pady=c(0,"0.4c"))
		tkgrid(Final_Population.but)
		tkgrid(Final_Population.ri.but)  
		tkgrid(lstFinal_Population)
		tkgrid.configure(Final_Population.but, pady=c(0,"0.2c"))
		tkgrid.configure(Final_Population.ri.but, pady=c("0.2c",0))

		############################################
		tkgrid(frameSize.but, frameSize, frameSize.ri.but)
		tkgrid.configure(frameSize.but, padx= c("0.1c"), pady=c("0.2c","0.2c"))
		tkgrid.configure(frameSize, padx= c(0,"0.1c"), pady=c(0,"0.1c"))
		tkgrid.configure(frameSize.ri.but, padx= c("0.1c"), pady=c(0,"0.4c"))
		tkgrid(Size.but)
		tkgrid(Size.ri.but)  
		tkgrid(lstSize)
		tkgrid.configure(Size.but, pady=c(0,"0.2c"))
		tkgrid.configure(Size.ri.but, pady=c("0.2c",0))
		
		###########################################	
		tkgrid.configure(entry.PSUsamplestr,  padx= c("1.2c"), pady=c(0,"0.3c"))
		tkgrid.configure(entry.Min_sample,  padx= c("1.2c"), pady=c(0,"0.3c"))
		
		############################################
		tkgrid(lblfAllDataSet)
		tkgrid(lblAllDataframe, lblAllVariables)
		
		tkgrid(lblSnpAllDataframe)
		tkgrid(lstAllDataFrame, scrAllDataSets)
		
		tkgrid.configure(lblAllDataframe, column=1, sticky ="e")
		tkgrid.configure(lblSnpAllDataframe, row=2, column=1)
		tkgrid.configure(lblAllVariables, column=4)

		tkgrid.configure(lstAllDataFrame, column=1, row=3, sticky ="e", padx=c("1.7c","0c"), pady=c(0,"0.2c"))
		tkgrid.configure(scrAllDataSets, column=2, row=3, sticky ="nsw", padx=c(0,"1.9c"), pady=c(0,"0.2c"))	
			
		###########################################	
		tkgrid(frameFinal_sample.but, frameFinal_sample, frameFinal_sample.ri.but)
		tkgrid.configure(frameFinal_sample.but, padx= c("0.1c"), pady=c("0.2c","0.2c"))
		tkgrid.configure(frameFinal_sample, padx= c(0,"0.1c"), pady=c(0,"0.1c"))
		tkgrid.configure(frameFinal_sample.ri.but, padx= c("0.1c"), pady=c(0,"0.4c"))
		tkgrid(Final_sample.but)
		tkgrid(Final_sample.ri.but)  
		tkgrid(lstFinal_sample)
		tkgrid.configure(Final_sample.but, pady=c(0,"0.2c"))
		tkgrid.configure(Final_sample.ri.but, pady=c("0.2c",0))
			
		###########################################	
		tkgrid(frameAllDomain.but, frameAllDomain, frameAllDomain.ri.but)
		tkgrid.configure(frameAllDomain.but, padx= c("0.1c"), pady=c("0.2c","0.2c"))
		tkgrid.configure(frameAllDomain, padx= c(0,"0.1c"), pady=c(0,"0.1c"))
		tkgrid.configure(frameAllDomain.ri.but, padx= c("0.1c"), pady=c(0,"0.4c"))
		tkgrid(AllDomain.but)
		tkgrid(AllDomain.ri.but)  
		tkgrid(lstAllDomain)
		tkgrid.configure(AllDomain.but, pady=c(0,"0.2c"))
		tkgrid.configure(AllDomain.ri.but, pady=c("0.2c",0))

		###########################################
		tkgrid(lblData, pady=c("0.2c",0))
		tkgrid(frameTop)
		tkgrid(frameGlobalFileFirst)
		tkgrid(frameFileFirst)
		tkgrid(frameCentralTop)
		tkgrid(frameCentralDown)
		
		tkgrid(lblAllData, pady=c("0.2c",0))
		tkgrid(frameGlobalFileAll)
		
		tkgrid(frameTopFileAll)
		tkgrid(frameFileAll)
		
		#####################################################	
		tkgrid(labelLaunchF,rbLaunchF)
		tkgrid(labelLaunchT,rbLaunchT)

		tkgrid.configure(labelLaunchF, sticky="w", padx=c("0.3c",0))
		tkgrid.configure(labelLaunchT, sticky="w", padx=c("0.3c",0))

		tkgrid(lblfLaunch)
		tkgrid.configure(lblfLaunch, padx=c("0.5c",0), pady=c("0.2c","0.2c"))
		
		tkgrid(frameLaunch) 
		
		###############################	
		tkgrid(lblfOutputObj)
		
		tkgrid(lblObjectNameRes1, lblObjectNameRes2, lblObjectNameRes3, lblObjectName)
		tkgrid.configure(lblObjectNameRes1, padx=c("0.2c","0.2c"))
		tkgrid.configure(lblObjectNameRes2, padx=c("0.2c","0.2c"))
		tkgrid.configure(lblObjectNameRes3, padx=c("0.2c","0.2c"))
		tkgrid.configure(lblObjectName, padx=c("0.2c","0.2c"))

		tkgrid(entry.ObjectNameRes1, entry.ObjectNameRes2, entry.ObjectNameRes3, entry.ObjectName)
		tkgrid.configure(entry.ObjectNameRes1, padx=c("0.2c","0.2c"))
		tkgrid.configure(entry.ObjectNameRes2, padx=c("0.2c","0.2c"))
		tkgrid.configure(entry.ObjectNameRes3, padx=c("0.2c","0.2c"))
		tkgrid.configure(entry.ObjectName, padx=c("0.2c","0.2c"))

		tkgrid(frameOutput)
		tkgrid.configure(frameOutput)
		
		tkgrid(frameButtons)
		tkgrid.configure(frameButtons, sticky="ne")
		tkgrid(ok.but, Cancel.but, FunctionHelp.but)
		tkgrid.configure(Cancel.but, padx=("0.5c"))
		tkgrid.configure(FunctionHelp.but, padx=c(0,"0.5c"))	
		
		tkgrid(frameGlobal)
	}
}

					
fListFields <- function(St_lista, St_lstDataFrame, St_lblVariables, x, St_lstVariables, St_scr, St_lblSnpDataframe, 
	St_ID_PSU.but, St_ID_PSU.ri.but, St_Domain.but, St_Domain.ri.but, St_Final_Population.but, 
	St_Final_Population.ri.but, St_Size.but, St_Size.ri.but, St_lstID_PSU, St_lstDomain, St_lstFinal_Population,
	St_lstSize, St_entry.PSUsamplestr, St_entry.Min_sample){
										
	St_indicesel <- tclvalue(tkcurselection(St_lstDataFrame))
																					
	assignTemp("Scelta_DataFrame_Name", as.character(tclObj(St_lista))[as.integer(tkcurselection(St_lstDataFrame))+1])
					
	Scelta_DataFrame_Value <- get(Scelta_DataFrame_Name, envir=.GlobalEnv)
	VarScelta_DataFrame <<- tclVar(Scelta_DataFrame_Name)
	tkconfigure(St_lblSnpDataframe, textvariable= VarScelta_DataFrame)
								
	if (Index_dataframe_old != St_indicesel)
		count <<- FALSE
									
		if (count == FALSE){
			count <<- TRUE
			Index_dataframe_old <<- St_indicesel
						
			tclObj(x) <- names(Scelta_DataFrame_Value)
						
			tkdelete(St_lstID_PSU, 0, "end")
			tkdelete(St_lstDomain, 0, "end")
			tkdelete(St_lstFinal_Population, 0, "end")
			tkdelete(St_lstSize, 0, "end")
												
			tkgrid(St_lstVariables, St_scr)
			tkgrid.configure(St_lstVariables, column = 4, row = 3, pady = c(0, "0.2c"), sticky = "e")
			tkgrid.configure(St_scr, column = 5, row = 3, padx = c("0c", "1.7c"), pady = c(0, "0.2c"), sticky = "nsw")
           											
			tkconfigure(St_ID_PSU.but, state = "normal") 
			tkconfigure(St_Domain.but, state = "normal")
			tkconfigure(St_Final_Population.but, state = "normal") 
			tkconfigure(St_Size.but, state = "normal") 
											
			tkconfigure(St_ID_PSU.ri.but, state = "normal") 
			tkconfigure(St_Domain.ri.but, state = "normal")
			tkconfigure(St_Final_Population.ri.but, state = "normal")
			tkconfigure(St_Size.ri.but, state = "normal") 
												
			tkconfigure(St_entry.PSUsamplestr, state = "normal") 
			if (Min_sample_index == TRUE){
				tkconfigure(St_entry.Min_sample, state = "disabled") 
			}
			else{
				tkconfigure(St_entry.Min_sample, state = "normal") 
			}
			tkconfigure(St_lblVariables, text="Variables", state = "normal")
    	} 
}	
	
	
fAllListFields <- function(St_Min_sample, St_Alllista, St_lstAllDataFrame, St_lblAllVariables, x, St_lstAllVariables, St_scrAll, 
	St_lblSnpAllDataframe, St_AllDomain.but, St_AllDomain.ri.but, St_Final_sample.but, St_Final_sample.ri.but,
	St_planned_min_sample.but, St_planned_min_sample.ri.but, St_lblfplanned_min_sample, St_lstFinal_sample, 
	St_lstAllDomain, St_lstplanned_min_sample, St_frameplanned_min_sample.but, St_frameplanned_min_sample.ri.but, 
	St_frameplanned_min_sample, St_entry.Min_sample, St_ok.but){
											
	St_indicesel <- tclvalue(tkcurselection(St_lstAllDataFrame))
																					
	assignTemp("All_DF_Name", as.character(tclObj(St_Alllista))[as.integer(tkcurselection(St_lstAllDataFrame))+1])
	All_DF_Value <- get(All_DF_Name, envir=.GlobalEnv)
	VarScelta_DF_All <<- tclVar(All_DF_Name)
	tkconfigure(St_lblSnpAllDataframe, textvariable= VarScelta_DF_All)
								
	if (Index_dataframe_oldAll != St_indicesel)
		countAll <<- FALSE
									
		if (countAll == FALSE){
			countAll <<- TRUE
			Index_dataframe_oldAll <<- St_indicesel
							
			tclObj(x) <- names(All_DF_Value)
							
			tkdelete(St_lstFinal_sample, 0, "end")
			tkdelete(St_lstAllDomain, 0, "end")
			tkdelete(St_lstplanned_min_sample, 0, "end")
							
			tkgrid(St_lstAllVariables, St_scrAll)
			tkgrid.configure(St_lstAllVariables, column = 4, row = 3, pady = c(0, "0.2c"), sticky = "e")
			tkgrid.configure(St_scrAll, column = 5, row = 3, padx = c("0c", "1.7c"), pady = c(0, "0.2c"), sticky = "nsw")
						
			tkconfigure(St_Final_sample.but, state = "normal") 
			tkconfigure(St_AllDomain.but, state = "normal")
									
			tkconfigure(St_Final_sample.ri.but, state = "normal") 
			tkconfigure(St_AllDomain.ri.but, state = "normal") 
							
			tkconfigure(St_ok.but, state = "normal")
							
			tkconfigure(St_lblAllVariables, text="Variables", state = "normal")
							
			tkgrid.configure(St_lblfplanned_min_sample,padx=c(0,"0.3c"), pady=c(0,"0.2c"))	 
			
			if  (tclvalue(St_Min_sample)==""){
				Min_sample_index <<- TRUE
									
				tkconfigure(St_entry.Min_sample, state = "disabled") 		
			
				tkgrid(St_frameplanned_min_sample.but, St_frameplanned_min_sample, St_frameplanned_min_sample.ri.but)
				tkgrid.configure(St_frameplanned_min_sample.but, padx= c("0.1c"), pady=c("0.2c","0.2"))
				tkgrid.configure(St_frameplanned_min_sample, padx= c(0,"0.1c"), pady=c(0,"0.1c"))
				tkgrid.configure(St_frameplanned_min_sample.ri.but, padx= c("0.1c"), pady=c(0,"0.4c"))
				tkgrid(St_planned_min_sample.but)
				tkgrid(St_planned_min_sample.ri.but)  
				tkgrid(St_lstplanned_min_sample)
									
				tkgrid.configure(St_planned_min_sample.but, pady=c(0,"0.2c"))
				tkgrid.configure(St_planned_min_sample.ri.but, pady=c("0.2c",0))

				tkconfigure(St_planned_min_sample.but, state = "normal") 
				tkconfigure(St_planned_min_sample.ri.but, state = "normal") 
			}					
		}
}	


fMove<- function(lstMove, St_lstVariables, x){
sel <- as.integer(tkcurselection(St_lstVariables))
selleng <- length(sel)
	if (selleng==0){
		tkmessageBox(title="Selection", message = "Please select a variable", icon = "warning")
	}
	else{
		for (i in 1:selleng){ 
			selection <- as.character(tclObj(x))[as.integer(tkcurselection(St_lstVariables))+1]
			tkinsert(lstMove, "end", selection[i])
			}
		}
}

	
fRemove <- function(lstRemove, St_lstVariables, x){
num <- as.integer(tksize(lstRemove))
	if  (num ==0){
		tkmessageBox(title="Selection", message="No element transferred", icon = "warning")
	}
	else{
		sel <- as.integer(tkcurselection(lstRemove))	
		selleng <- length(sel)
		if (selleng==0)
			tkmessageBox(title="Selection", message = "Please select an element", icon = "warning")
		else{
		    while (selleng>0){
				selection <- as.character(tclObj(x))[as.integer(tkcurselection(lstRemove))+1]
				tkdelete(lstRemove, sel[selleng])
				selleng <- selleng - 1
			}	
		}
	}
}


fDetransfer <- function(lstRitransfer, lstEC_DataFrame, x){
num <- as.integer(tksize(lstRitransfer))
if  (num ==0){
     tkmessageBox(title="Selection", message="No element transferred",icon = "warning")
    }
else {
     indicesel <- as.integer(tkcurselection(lstRitransfer))
     sleng <- length(indicesel)
     if (sleng==0){
         tkmessageBox(title="Selection", message = "Please select an element", icon = "warning")
        }
     else{
          for (i in 1:sleng){
               sel <- as.character(tclObj(x))[as.integer(tkcurselection(lstRitransfer))+1]
               tkinsert(lstEC_DataFrame, "end", sel[i])
            }
          while (sleng>0){
                 sel <- as.character(tclObj(x))[as.integer(tkcurselection(lstRitransfer))+1]
                 tkdelete(lstRitransfer, indicesel[sleng])
                 sleng <- sleng - 1
            }
        }
    }
}
	

###########################################
# Function is.ok.name retrieved from      #
# ReGenesees.GUI with some modifications. #
# Checks if an identifier is good  (i.e.  #
# syntactically valid and unique) as name #
# of an output object.                    #
###########################################	
is.ok.name <- function(name, go.on = TRUE){
# test if validity checks are not
# needed, due to previous errors
if (!go.on) return(FALSE)

ok <- ( length(name) == 1  &&
        is.character(name) &&
        name == make.names(name)
      )
if (!ok) {
          tkmessageBox(title="An error has occurred!", 
                       message="Invalid output data frame name", 
                       icon="error", type="ok")
		 }
else {
      if ( name %in% ls(.GlobalEnv) ) {
          ans <- tclvalue(tkmessageBox(title="Output data frame name", 
                                       message=paste("A data frame named '",
                                                     name,
                                                     "' already exists!\nDo you want to overwrite it?", sep=""), 
                                       icon="question", type="yesno", default="no"))
          if (ans == "no") ok <- FALSE
        }
    }
ok
}

				
fOnCancel <- function(Canc_tt){
	tkgrab.release(Canc_tt)
	tkdestroy(Canc_tt)
}			


fOnRun <- function(St_lstID_PSU, St_lstDomain, St_lstFinal_Population, St_lstFinal_sample, St_lstSize, St_lstAllDomain, 
	St_entry.PSUsamplestr, St_entry.Min_sample, St_lstplanned_min_sample, St_rbValueLaunch, St_ObjectNameRes1, 
	St_ObjectNameRes2, St_ObjectNameRes3, St_ObjectName, ttStratification){
				
	campobb <- TRUE
	Scelta_DataFrame_Value <- get(Scelta_DataFrame_Name, envir=.GlobalEnv)
	All_DF_Value <- get(All_DF_Name, envir=.GlobalEnv)
			
	num <- as.integer(tksize(St_lstID_PSU))
	if  (num == 0) {
		tkmessageBox(title="ID_PSU list empty", message = "The list is empty. Transfer one element", icon = "error")
		campobb <- FALSE
	}
	else{
		if  (num>1){
		    tkmessageBox(title="ID_PSU list", message = "The list has to contain only one variable", icon = "error")
			campobb <- FALSE
		}
		else{
			ID_PSU <- tclvalue(tkget(St_lstID_PSU, 0, 0))
			idpsu <- as.formula(paste("~", ID_PSU), env = .GlobalEnv)
								
			prnID_PSU <- paste("idpsu=", ID_PSU, sep =" ~ ")
		}
	}	
		
		
	num <- as.integer(tksize(St_lstDomain))
	if  (num == 0) {
		tkmessageBox(title="Domain list empty", message = "The list is empty. Transfer one element", icon = "error")
		campobb <- FALSE
	}
	else{
		if  (num>1){
		    tkmessageBox(title="Domain list", message = "The list has to contain only one variable", icon = "error")
		    campobb <- FALSE
		}
		else{
			Dom <- tclvalue(tkget(St_lstDomain, 0, 0))
			dom <- as.formula(paste("~", Dom), env = .GlobalEnv)
			prnDom <- paste("dom=", Dom, sep =" ~ ")
		}
	}	
			
			
	num <- as.integer(tksize(St_lstFinal_Population))
	if  (num == 0) {
	    tkmessageBox(title="Final Population list empty", message = "The list is empty. Transfer one element", icon = "error")
	    campobb <- FALSE
	}
	else{
	    if  (num>1){
	        tkmessageBox(title="Final Population list", message = "The list has to contain only one variable", icon = "error")
	        campobb <- FALSE
	    }
		else{
		    Final_Population <- tclvalue(tkget(St_lstFinal_Population, 0, 0))
			final_pop <- as.formula(paste("~", Final_Population), env = .GlobalEnv)
			prnFinal_Population <- paste("final_pop=", Final_Population, sep =" ~ ")
		}
	}	

	
	num <- as.integer(tksize(St_lstSize))
	if  (num == 0) {
	    tkmessageBox(title="Size PSU list empty", message = "The list is empty. Transfer one element", icon = "error")
	    campobb <- FALSE
	}
	else{
	    if  (num>1){
	        tkmessageBox(title="Size PSU list", message = "The list has to contain only one variable", icon = "error")
	        campobb <- FALSE
	    }
		else{
		    Size <- tclvalue(tkget(St_lstSize, 0, 0))
			size <- as.formula(paste("~", Size), env = .GlobalEnv)
			prnSize <- paste("size=", Size, sep =" ~ ")
			}
	}
		
		
	PSUsamplestr <- tclvalue(tkget(St_entry.PSUsamplestr))						
	if (PSUsamplestr ==""){
		tkmessageBox(title="PSU sample stratum", message="The field is empty!",icon="error")
		campobb <- FALSE
	}
	else{
		PSUsamplestr <- as.numeric(tkget(St_entry.PSUsamplestr))
		if (is.na(PSUsamplestr)){
			tkmessageBox(title="PSU sample stratum", message="Please insert a numeric value",icon="error")
			campobb <- FALSE
		}
		else{
			prnPSUsamplestr <- paste("PSUsamplestratum= ", PSUsamplestr, sep="")
		}
	}	
	
	
	if (Min_sample_index == FALSE){
		Min_sample <- tclvalue(tkget(St_entry.Min_sample))						
		if (Min_sample ==""){
			tkmessageBox(title="Min sample", message="The field is empty!",icon="error")
			campobb <- FALSE
		}
		else{
			Min_sample <- as.numeric(tkget(St_entry.Min_sample))
			if (is.na(Min_sample)){
				tkmessageBox(title="Min sample", message="Please insert a numeric value",icon="error")
				campobb <- FALSE
			}
			else{
				prnMin_sample <- paste("min_sample= ", Min_sample, sep="")
			}
		}			
	}	
	else{
		Min_sample <- NULL
		prnMin_sample <- paste("min_sample= NULL")
	}
			
			
	num <- as.integer(tksize(St_lstFinal_sample))
	if  (num == 0) {
	    tkmessageBox(title="Final_sample list empty", message = "The list is empty. Transfer one element", icon = "error")
	    campobb <- FALSE
	}
	else{
	    if  (num>1){
	        tkmessageBox(title="Final_sample list", message = "The list has to contain only one variable", icon = "error")
	        campobb <- FALSE
	    }
		else{
	        Final_sample <- tclvalue(tkget(St_lstFinal_sample, 0, 0))
			f_sample <- as.formula(paste("~", Final_sample), env = .GlobalEnv)
			prnFinal_sample <- paste("f_sample=", Final_sample, sep =" ~ ")
	    }
	}	
		
		
	num <- as.integer(tksize(St_lstAllDomain))
	if  (num == 0) {
	    tkmessageBox(title="Allocation Domain list empty", message = "The list is empty. Transfer one element", icon = "error")
	    campobb <- FALSE
	}
	else{
	    if  (num>1){
	        tkmessageBox(title="Allocation Domain list", message = "The list has to contain only one variable", icon = "error")
			campobb <- FALSE
		}
		else{
		    AllDomain <- tclvalue(tkget(St_lstAllDomain, 0, 0))
			domAll <- as.formula(paste("~", AllDomain), env = .GlobalEnv)
			prnAllDomain <- paste("domAll=", AllDomain, sep =" ~ ")
		}
	}	
		
		
	if (Min_sample_index == TRUE){
		prnMin_sample_index <- "min_sample_index= TRUE"
		num <- as.integer(tksize(St_lstplanned_min_sample))
		if  (num == 0) {
			tkmessageBox(title="planned_min_sample list empty", message = "The list is empty. Transfer one element", icon = "error")
			campobb <- FALSE
		}
		else{
			if  (num>1){
				tkmessageBox(title="planned_min_sample list", message = "The list has to contain only one variable", icon = "error")
				campobb <- FALSE
			}
			else{
				Planned_min_sample <- tclvalue(tkget(St_lstplanned_min_sample, 0, 0))
				planned_min_sample <- as.formula(paste("~", Planned_min_sample), env = .GlobalEnv)
				prnPlanned_min_sample <- paste("planned_min_sample=", Planned_min_sample, sep =" ~ ")
			}
		}	
	}
	else{
		prnMin_sample_index <- "min_sample_index= FALSE"
		prnPlanned_min_sample <- "planned_min_sample= NULL"
		planned_min_sample <- NULL
	}
			
			
	Launch <- as.logical(tclvalue(St_rbValueLaunch))
			
		if  (!Launch){
			prnLaunch <- "launch= FALSE"
			if  (tclvalue(St_ObjectNameRes1)==""){
				tkmessageBox(title="Output data frame name ", message="Please give a name to Domain result 1",icon="error")
				campobb <- FALSE
			}
			else{
				if   ( !is.ok.name(tclvalue(St_ObjectNameRes1), go.on=campobb) ){
					campobb <- FALSE
				}
				else {		
					 St_ObjectNameRes1 <- tclvalue(St_ObjectNameRes1)
				}
			}
				
			if  (tclvalue(St_ObjectNameRes2)==""){
				tkmessageBox(title="Output data frame name ", message="Please give a name to Domain result 2",icon="error")
				campobb <- FALSE
			}
			else{
				if   ( !is.ok.name(tclvalue(St_ObjectNameRes2), go.on=campobb) ){
						campobb <- FALSE
				}
				else {		
					 St_ObjectNameRes2 <- tclvalue(St_ObjectNameRes2)
				}
			}
				
			if  (tclvalue(St_ObjectNameRes3)==""){
				tkmessageBox(title="Output data frame name ", message="Please give a name to Domain result 3",icon="error")
				campobb <- FALSE
			}
			else{
				if   ( !is.ok.name(tclvalue(St_ObjectNameRes3), go.on=campobb) ){
					campobb <- FALSE
				}
				else {		
					 St_ObjectNameRes3 <- tclvalue(St_ObjectNameRes3)
				}
			}
				
			if  (tclvalue(St_ObjectName)==""){
				tkmessageBox(title="Output data frame name ", message="Please give a name to Final result",icon="error")
				campobb <- FALSE
			}
			else{
				if   ( !is.ok.name(tclvalue(St_ObjectName), go.on=campobb) ){
					campobb <- FALSE
				}
			else {		
				 St_ObjectName <- tclvalue(St_ObjectName)
				}
			}
				
			vnames <- c(St_ObjectNameRes1, St_ObjectNameRes2, St_ObjectNameRes3, St_ObjectName)
			vnames <- vnames[duplicated(vnames)]
			if (length(vnames)!=0){
				tkmessageBox(title="Duplicated object name ", message="Please give not duplicated names",icon="error")
				campobb <- FALSE
			}
		}	
					
		else{
			prnLaunch <- "launch= TRUE"
			if  (tclvalue(St_ObjectNameRes1)==""){
				tkmessageBox(title="Output data frame name ", message="Please give a name to Domain result 1",icon="error")
				campobb <- FALSE
			}
			else{
				if   ( !is.ok.name(tclvalue(St_ObjectNameRes1), go.on=campobb) ){
					campobb <- FALSE
				}
				else {		
					 St_ObjectNameRes1 <- tclvalue(St_ObjectNameRes1)
				}
			}
		}
			
			
		if  (campobb == TRUE){
			tkconfigure(ttStratification, cursor="watch")	
				
			listResults <- Shot(StratSel(Scelta_DataFrame_Value, idpsu, dom, final_pop, size,
											PSUsamplestr, Min_sample, Min_sample_index, All_DF_Value, 
											domAll, f_sample, planned_min_sample, Launch), textWarnings)				
								 				                            
			if (!inherits(listResults,"try-error")) {
					
				attr(listResults,"dataPop") <- as.symbol(Scelta_DataFrame_Name)
				attr(listResults,"dataAll") <- as.symbol(All_DF_Name)
					
				prnDataPop <- paste("dataPop=", Scelta_DataFrame_Name)
				prnDataAll <- paste("dataAll=", All_DF_Name)
					
				if (Launch){
						
					assign(St_ObjectNameRes1, listResults, envir = .GlobalEnv)	
					cat("\n")
					cat(paste("# ",St_ObjectNameRes1,"\n",sep=""))
					print(listResults)
					cat("\n")
						
					prnStratSel <- paste(" <- StratSel(", prnDataPop, ", ", prnID_PSU, ", ",
													prnDom, ", ", prnFinal_Population, ", ", prnSize, ", ",
													prnPSUsamplestr, ", ", prnMin_sample, ", ", prnMin_sample_index, ", ",
													prnDataAll, ", ", prnAllDomain, ", ", prnFinal_sample, ", ",
													prnPlanned_min_sample, ", ", prnLaunch,")", sep="")
						
						
					commandsR <- paste(St_ObjectNameRes1, prnStratSel, "\n", sep="")
						
					tkconfigure(textHistory, state="normal")
					tkinsert(textHistory, "end", commandsR)
					tkinsert(textHistory, "end", "\n")
					tkyview.moveto(textHistory, 1.0)
					tkconfigure(textHistory, state="disabled")
										
					tkgrab.release(ttStratification)
					tkconfigure(ttStratification, cursor="arrow")
					tkmessageBox(title ="Stratification and Selection",message = "Operation executed", icon = "info")	
						
					campobb <- FALSE
				}
				else{
					assign(St_ObjectNameRes1, listResults[[1]], envir = .GlobalEnv)
					assign(St_ObjectNameRes2, listResults[[2]], envir = .GlobalEnv)
					assign(St_ObjectNameRes3, listResults[[3]], envir = .GlobalEnv)
					assign(St_ObjectName, listResults[[4]], envir = .GlobalEnv)
										
					prnStratSel <- paste(" <- StratSel(", prnDataPop, ", ", prnID_PSU, ", ",
													prnDom, ", ", prnFinal_Population, ", ", prnSize, ", ",
													prnPSUsamplestr, ", ", prnMin_sample, ", ", prnMin_sample_index, ", ",
													prnDataAll, ", ", prnAllDomain, ", ", prnFinal_sample, ", ",
													prnPlanned_min_sample, ", ", prnLaunch,")", sep="")
											
					commandsT <- paste("Output_list", prnStratSel, "\n", sep="")

					tkconfigure(textHistory, state="normal")
					tkinsert(textHistory, "end", commandsT)
					tkinsert(textHistory, "end", "\n")
					tkyview.moveto(textHistory, 1.0)
					tkconfigure(textHistory, state="disabled")
					
					tkgrab.release(ttStratification)
						
					tkmessageBox(title ="Stratification and Selection",message = "Operation executed", icon = "info")	
				}	
			}
			tkconfigure(ttStratification, cursor="arrow")	
			gc()				
		}
	}				
}
