\name{FS4}
\alias{FS4}
\alias{FS4}
\docType{package}
\title{First Stage Stratification and Selection in Sampling
}
\description{
Starts a user friendly GUI (graphical user interface) that allows to access the functionality of the package for first stage stratification and selection in sampling related to two or more stages. 
}
\usage{
FS4()
}

\details{
The main window of the GUI consists of a menu bar and, from the top to the bottom, of two scrollable text windows called "Commands Window" and "Warnings Window". The menu bar consists, from left to right, of the following menu items: "File", "Data", "Functions", "Tools", "Results" and "Help" (see section 'Menu Tree').\cr 

Menus "Data" and "Functions" lead to dialog boxes that need further specifications, while the others ("File", "Tools", "Results" and "Help") allow directly to have the results of commands.\cr

File import and data frame export, in ".txt" and ".csv" formats, are available through "Data" menu. Display and removal of output data frames and of those belonging to user's workspaces, are possible through specific functions of "Tools" menu. With "Results" menu is possible display only all the data frames outputs. \cr

The main form is "Stratification and Selection": it allows user to choose two data frames stored into the user's workspace (GlobalEnv): PSU (Primary Sampling Unit) population and allocation data frames. The choice of each of them, displays the list of variables that forms it, some of which must be selected to populate the form. The input parameters required are represented by the number of sample PSUs to select in each stratum and by the single or multiple size of the planned final sample units to observe in each PSU. It is possible to launch the procedure in two steps, (in this case the launch is "partial" and radio button is setted on "Yes" by default), so allowing to the user to view the output result and, on the basis of this, modify the input parameters and launch newly the process. With the exception of the "partial launch", the required output fields are four.  They refer to the names that the user must assign to the output data frames made available: the first two at domain level, the third and fourth respectively at stratum and PSU level. The first output displays the list of the Self Representative (SR) PSUs and of the Non Self Representative (NSR) PSUs before the stratification of the whole NSR PSUs. In the second output is added the sample size of the final units distinct for SR and NSR PSUs, after the stratification. The third output shows, for each stratum, the number of sample PSUs and the PSUs total number. The fourth output provides, for each PSU, some information such as, for example, the probability of inclusion and the sampling fraction. FS4 defines, for each PSU, the final sample unit size, by the sizes, single or plural (variable between domains), planned in input. All the entries of this form have been supplied with tooltips.\cr  

By default, commands generated by the GUI are inserted to the Commands Window (is possible to save commands via \emph{File -> Save Commands} or copy them by pressing \emph{Control-C} or right-clicking the mouse). Warning messages are displayed in the Warnings Window, instead error messages, producing the stop of computation, are always displayed by means of pop-up dialogs.\cr

In addition to "Help" menu, for each dialog box coming from "Data" and "Functions" menus is available a help button that links to the connected help pages from the corresponding source.\cr

The end of a GUI session is possible either using the \emph{File - > Exit} menu or by closing the FS4 main window.\cr
\cr

}
\section{Menu Tree}{
The menu "tree" for this FS4 package (version 2.0) is shown below.\cr
\tabular{lll}{ 
\tab\cr
| File \tab  \tab  \cr
| --------------------------------------\tab  \tab  \cr
  \tab | - Change Directory \tab  \cr
  \tab | - Load Workspace \tab  \cr
  \tab | - Save Workspace \tab  \cr
  \tab | - Save Commands \tab  \cr	
  \tab | - Exit \tab  \cr
\tab\cr
| Data \tab  \tab  \cr
| --------------------------------------\tab  \tab  \cr
  \tab | - Import Datasets \tab  \cr 
\tab | --------------------------------------\tab  \cr
  \tab  \tab | - From Text Files\cr
  \tab | - Export Datasets \tab  \cr
\tab\cr
| Functions \tab  \tab  \cr
| --------------------------------------\tab  \tab  \cr
  \tab | - Stratification and Selection \tab  \cr
\tab\cr
| Tools \tab  \tab  \cr
| --------------------------------------\tab  \tab  \cr
  \tab | - Show Datasets \tab  \cr
  \tab | - Remove datasets \tab  \cr
\tab\cr
| Results \tab  \tab  \cr
| --------------------------------------\tab  \tab  \cr
  \tab | - Show results \tab  \cr
\tab\cr
| Help \tab  \tab  \cr
| --------------------------------------\tab  \tab  \cr
  \tab | - R Help on FS4 \tab  \cr
  \tab | - FS4 2.0 Reference Manual \tab  \cr
  \tab | - FS4 2.0 User Guide \tab  \cr
\tab\cr
	}
}

\author{
Raffaella Cianchetta
}

\note{
This is a Windows version, FS4() can properly run under the \emph{Rgui} in the SDI (single-document interface) mode.\cr
}

\references{
R. Cianchetta (2013), In arrivo FS4, nuovo software open source per il campionamento, \emph{NewsStat n. 8}, p. 20, \url{http://www.istat.it/it/files/2013/06/NewsStat-8_2013-19_giu_2013-pag.20.pdf}.
}

\examples{
# Start FS4
\dontrun{
FS4()
}
}